Package: methylscaper
Type: Package
Title: Visualization of Methylation Data
Description: methylscaper is an R package for processing and visualizing data jointly
  profiling methylation and chromatin accessibility (MAPit, NOMe-seq, scNMT-seq, nanoNOMe,
  etc.). The package supports both single-cell and single-molecule data, and 
  a common interface for jointly visualizing both data types through the generation of
  ordered representational methylation-state matrices. The Shiny app allows for an 
  interactive seriation process of refinement and re-weighting that optimally 
  orders the cells or DNA molecules to discover methylation patterns and nucleosome 
  positioning.
Version: 1.21.0
Authors@R: c(person("Bacher", "Rhonda", email = "rbacher@ufl.edu", role = c("aut", "cre")), person("Parker", "Knight", role = c("aut")))
Depends: R (>= 4.4.0)
License: GPL-2
Encoding: UTF-8
Imports: shiny, shinyjs, seriation, BiocParallel, seqinr, Biostrings,
        pwalign, Rfast, grDevices, graphics, stats, utils, tools,
        methods, shinyFiles, data.table, SummarizedExperiment
RoxygenNote: 7.3.2
Suggests: BiocStyle, knitr, rmarkdown, devtools, R.utils
VignetteBuilder: knitr
biocViews: DNAMethylation, Epigenetics, Sequencing, Visualization,
        SingleCell, NucleosomePositioning
URL: https://github.com/rhondabacher/methylscaper/
BugReports: https://github.com/rhondabacher/methylscaper/issues
git_url: https://git.bioconductor.org/packages/methylscaper
git_branch: devel
git_last_commit: 013af48
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-29
NeedsCompilation: no
Packaged: 2026-04-29 22:53:10 UTC; biocbuild
Author: Bacher Rhonda [aut, cre],
  Parker Knight [aut]
Maintainer: Bacher Rhonda <rbacher@ufl.edu>

# methylscaper

`methylscaper` is an R package for visualizing data that jointly profile endogenous methylation and chromatin accessibility (MAPit, NOMe-seq, scNMT-seq, nanoNOMe, etc.). The package offers pre-processing for single-molecule data and accepts input from Bismark (or similar alignment programs) for single-cell data. A common interface for visualizing both data types is constructed by generating ordered representational methylation-state matrices. The package provides a Shiny app to allow for interactive and optimal ordering of the individual DNA molecules to discover methylation patterns, nucleosome positioning, and transcription factor binding.

# Webserver

`methylscaper` is available for use on a webserver located at [www.methylscaper.com](http://www.methylscaper.com) and clicking on "Start Shiny App". Also located on the website is easy access to the vignette and example datasets to use.

# Installation

For local use of methylscaper, it can be installed into R from [Bioconductor](http://bioconductor.org/packages/devel/bioc/html/methylscaper.html) (using R version > 4.1.0): 

```{r}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("methylscaper")
```

Alternatively, the version specified by the `ref` parameter below only requires R >= 4.0 (current stable release).

```{r}
if (!requireNamespace("devtools", quietly=TRUE))
    install.packages("devtools")
devtools::install_github("rhondabacher/methylscaper", ref="R4.0")
```

# Dependencies

Note: on Ubuntu, users may need to install libgsl via:
`sudo apt-get install libgsl-dev`

The following packages are required for methylscaper. If installation fails, you may need to manually install the dependencies using the function 'install.packages' for CRAN packages or 'BiocManager::install' for Bioconductor packages.

* CRAN packages: shiny, shinyjs, shinyFiles, seriation, seqinr, Rfast, data.table
* Bioconductor packages: BiocParallel, Biostrings, SummarizedExperiment


For any other installation issues/questions please leave a message on our [Github Issues](https://github.com/rhondabacher/methylscaper/issues).

# Manuscript

The methylscaper manuscript is now available at [Bioinformatics](https://academic.oup.com/bioinformatics/advance-article/doi/10.1093/bioinformatics/btab438/6298588). 

# Running methylscaper

To load the package into R:

```{r}
library(methylscaper)
```

To use methylscaper as a Shiny App:
```{r}
methylscaper::methylscaper()
```

Many more details and examples on how to use the Shiny App or functions directly in R are located in the vignette:

* [Vignette](http://bioconductor.org/packages/devel/bioc/vignettes/methylscaper/inst/doc/methylScaper.html)


# Contact/Maintainer

* [Rhonda Bacher](https://www.rhondabacher.com) (rbacher@ufl.edu)  
Department of Biostatistics, University of Florida

server <- function(input, output, session) {
    actionsLog <- reactiveValues(log = c("")) # logs the actions taken wrt the plot

    ####################
    # Single-cell data #
    ####################

    sc_seq_data <- reactiveValues(gch = NULL, hcg = NULL) # for raw data
    sc_raw_data <- reactiveValues(gch = NULL, hcg = NULL)
    sc_input_data <- reactiveValues(gch = NULL, hcg = NULL) # for state matrices
    sc_input_folder <- reactiveValues(path = NULL)
    mouse_bm <- NULL
    human_bm <- NULL
    singlecell_subset <- NULL
    singlemolecule_example <- NULL
    outname <- reactiveValues(usename = "example_data")
    outname_rds <- reactiveValues(usename = "example_data")

    ## preprocessing tab
    observe({
        if (is.null(input$sc_rds_file) & input$seriate_sc == "Preprocessing" & input$big_tab == "Single-cell") {
            showNotification("Please select the input files to begin",
                type = "message", duration = 4
            )
        }
    })

    observeEvent(input$run_subset, {
        validate(need(!is.null(input$sc_met_files$name[1]) & !is.null(input$sc_acc_files$name[1]),
            message = "Please choose an input directory.", label = "sc_input_folder"
        ))

        progress <- Progress$new()
        progress$set(message = "Loading single-cell data", value = 0)
        on.exit(progress$close())
        updateProgress <- function(value = NULL, message = NULL, detail = NULL) {
            progress$set(value = value, message = message, detail = detail)
        }
        showNotification(paste("Begin SC processing at chr", input$chromosome_number))

        dat_subset <- subsetSC(
            list(
                input$sc_met_files$datapath, input$sc_acc_files$datapath,
                input$sc_met_files$data, input$sc_met_files$data
            ),
            input$chromosome_number,
            updateProgress = updateProgress
        )

        showNotification("Done with single cell processing")
        sc_raw_data$gch <- dat_subset$gch
        sc_raw_data$hcg <- dat_subset$hcg
        rm(dat_subset)
        showNotification("Removed temporary raw data; Click button to download now.", duration = 3)
    })


    observe({
        if (is.null(sc_raw_data$gch)) {
            shinyjs::disable("sc_preprocessing_down")
        } else {
            shinyjs::enable("sc_preprocessing_down")
        }
    })

    output$sc_preprocessing_down <- downloadHandler(
        filename = function() {
            paste0("methylscaper_preprocessed_", input$chromosome_number, ".rds")
        },
        content = function(file) {
            validate(need(!is.null(sc_raw_data$gch) & !is.null(sc_raw_data$hcg),
                message = "Data has not been processed."
            ))
            print("Saving data")
            saveRDS(list(gch = sc_raw_data$gch, hcg = sc_raw_data$hcg), file = file)
            sc_raw_data$gch <- NULL
            sc_raw_data$hcg <- NULL
        }
    )

    ## Visualization tab


    observe({
        if (is.null(input$sc_rds_file) & input$seriate_sc == "Visualization" & input$big_tab == "Single-cell") {
            showNotification("Provide select the RDS file to begin",
                type = "message", duration = 4
            )
        }
        if (!is.null(input$sc_rds_file)) {
            isolate({
                progress <- Progress$new()
                progress$set(message = "Loading data", value = 0)
                on.exit(progress$close())
                temp <- readRDS(input$sc_rds_file$datapath)
                sc_seq_data$gch <- temp$gch
                sc_seq_data$hcg <- temp$hcg
                outname_rds$usename <- tools::file_path_sans_ext(input$sc_rds_file$name)
                actionsLog$log <- c(actionsLog$log, paste(
                    "Loading data:",
                    input$sc_rds_file$name
                ))
            })
            if (is.null(input$organism_choice)) {
                showNotification("Now select Organism and begin selecting genes",
                    type = "message", duration = 10
                )
            }
        }
    })

    # Genes <- reactiveValues()
    observeEvent(input$organism_choice, {
        if (!is.null(sc_seq_data$gch) & !is.null(sc_seq_data$hcg)) {
            if (input$organism_choice == "Human") {
                data("human_bm", package = "methylscaper", envir = environment())
                getchr <- sc_seq_data$gch[[1]]$chr[1]
                cg_max_pos <- suppressWarnings(max(vapply(sc_seq_data$hcg, FUN = function(x) {
                    max(x$pos, na.rm = TRUE)
                }, numeric(1))))
                cg_min_pos <- suppressWarnings(min(vapply(sc_seq_data$hcg, FUN = function(x) {
                    min(x$pos, na.rm = TRUE)
                }, numeric(1))))
                gc_max_pos <- suppressWarnings(max(vapply(sc_seq_data$gch, FUN = function(x) {
                    max(x$pos, na.rm = TRUE)
                }, numeric(1))))
                gc_min_pos <- suppressWarnings(min(vapply(sc_seq_data$gch, FUN = function(x) {
                    min(x$pos, na.rm = TRUE)
                }, numeric(1))))
                getmin <- pmin(cg_min_pos, gc_min_pos)
                getmin <- max(c(0, getmin - 100000))
                getmax <- pmax(cg_max_pos, gc_max_pos)
                getmax <- max(c(0, getmax + 100000))
                hum_bm_sub <- subset(
                    human_bm,
                    human_bm$chromosome_name == getchr &
                        human_bm$start_position >= getmin &
                        human_bm$end_position <= getmax
                )
                Genes <- sort(unique(hum_bm_sub$hgnc_symbol))
            } else if (input$organism_choice == "Mouse") {
                data("mouse_bm", package = "methylscaper", envir = environment())
                getchr <- sc_seq_data$gch[[1]]$chr[1]
                cg_max_pos <- suppressWarnings(max(vapply(sc_seq_data$hcg, FUN = function(x) {
                    max(x$pos, na.rm = TRUE)
                }, numeric(1))))
                cg_min_pos <- suppressWarnings(min(vapply(sc_seq_data$hcg, FUN = function(x) {
                    min(x$pos, na.rm = TRUE)
                }, numeric(1))))
                gc_max_pos <- suppressWarnings(max(vapply(sc_seq_data$gch, FUN = function(x) {
                    max(x$pos, na.rm = TRUE)
                }, numeric(1))))
                gc_min_pos <- suppressWarnings(min(vapply(sc_seq_data$gch, FUN = function(x) {
                    min(x$pos, na.rm = TRUE)
                }, numeric(1))))
                getmin <- pmin(cg_min_pos, gc_min_pos)
                getmin <- max(c(0, getmin - 100000))
                getmax <- pmax(cg_max_pos, gc_max_pos)
                getmax <- max(c(0, getmax + 100000))

                mouse_bm_sub <- subset(mouse_bm, mouse_bm$chromosome_name == getchr &
                    mouse_bm$start_position >= getmin &
                    mouse_bm$end_position <= getmax)
                Genes <- sort(unique(mouse_bm_sub$mgi_symbol))
            } else if (input$organism_choice == "Other") {
                Genes <- "Click here to begin manual start and end selection."
            }
            updateSelectizeInput(session, "geneList",
                choices = Genes,
                server = TRUE, selected = " "
            )
        }
    })



    output$startPos <- renderUI({
        if (!is.null(sc_seq_data$gch) & !is.null(sc_seq_data$hcg) & input$geneList != "") {
            if (input$organism_choice == "Mouse") {
                data("mouse_bm", package = "methylscaper", envir = environment())
                gene_select <- subset(mouse_bm, mouse_bm$mgi_symbol == input$geneList)
            }
            if (input$organism_choice == "Human") {
                data("human_bm", package = "methylscaper", envir = environment())
                gene_select <- subset(human_bm, human_bm$hgnc_symbol == input$geneList)
            }
            if (input$organism_choice == "Other") {
                cg_max_pos <- suppressWarnings(max(vapply(sc_seq_data$hcg, FUN = function(x) {
                    max(x$pos, na.rm = TRUE)
                }, numeric(1))))
                cg_min_pos <- suppressWarnings(min(vapply(sc_seq_data$hcg, FUN = function(x) {
                    min(x$pos, na.rm = TRUE)
                }, numeric(1))))
                gc_max_pos <- suppressWarnings(max(vapply(sc_seq_data$gch, FUN = function(x) {
                    max(x$pos, na.rm = TRUE)
                }, numeric(1))))
                gc_min_pos <- suppressWarnings(min(vapply(sc_seq_data$gch, FUN = function(x) {
                    min(x$pos, na.rm = TRUE)
                }, numeric(1))))


                start <- pmax(cg_min_pos, gc_min_pos)
                gene_select <- data.frame(start_position = start)
            }
            start <- gene_select$start_position
            numericInput(
                inputId = "startPos", label = "Start Position", min = 0,
                value = start
            )
        }
    })

    output$endPos <- renderUI({
        if (!is.null(sc_seq_data$gch) & !is.null(sc_seq_data$hcg) & input$geneList != "") {
            if (input$organism_choice == "Mouse") {
                data("mouse_bm", package = "methylscaper", envir = environment())
                gene_select <- subset(mouse_bm, mouse_bm$mgi_symbol == input$geneList)
            }
            if (input$organism_choice == "Human") {
                data("human_bm", package = "methylscaper", envir = environment())
                gene_select <- subset(human_bm, human_bm$hgnc_symbol == input$geneList)
            }
            if (input$organism_choice == "Other") {
                cg_max_pos <- suppressWarnings(max(vapply(sc_seq_data$hcg, FUN = function(x) {
                    max(x$pos, na.rm = TRUE)
                }, numeric(1))))
                cg_min_pos <- suppressWarnings(min(vapply(sc_seq_data$hcg, FUN = function(x) {
                    min(x$pos, na.rm = TRUE)
                }, numeric(1))))
                gc_max_pos <- suppressWarnings(max(vapply(sc_seq_data$gch, FUN = function(x) {
                    max(x$pos, na.rm = TRUE)
                }, numeric(1))))
                gc_min_pos <- suppressWarnings(min(vapply(sc_seq_data$gch, FUN = function(x) {
                    min(x$pos, na.rm = TRUE)
                }, numeric(1))))

                end <- pmax(cg_min_pos, gc_min_pos) + 5000
                gene_select <- data.frame(end_position = end)
            }
            end <- gene_select$end_position
            numericInput(
                inputId = "endPos", label = "End Position", min = 0,
                value = end
            )
        }
    })
    output$positionSlider <- renderUI({
        if (!is.null(sc_seq_data$gch) & !is.null(sc_seq_data$hcg) & input$geneList != "") {
            isolate({
                actionsLog$log <- c(
                    actionsLog$log,
                    paste("Current gene selected: ", input$geneList)
                )
            })

            if (!is.null(input$startPos) & !is.null(input$endPos)) {
                start <- input$startPos
                end <- input$endPos

                if (end - start > 50000) {
                    showNotification("Selected range is longer than 50k bp, plot may take a few
                        seconds to render", duration = 3)
                }
                if (end - start > 100000) {
                    showNotification("Selected range is longer than 100k bp, this is not optimal for
                        visualization, reducing to 100k bp.", duration = 10)

                    end <- start + 100000
                }
                if (start > end) {
                    end <- start + 2000
                }
                len <- end - start
                if (len > 0) {
                    sliderInput(
                        inputId = "positionSliderInput",
                        label = "Position adjustment slider",
                        min = start - len, max = end + len,
                        value = c(start, end)
                    )
                }
            }
        }
    })

    observe({
        if (!is.null(input$positionSliderInput)) {
            progress <- Progress$new()
            progress$set(message = "Beginning single-cell processing", value = 0)
            on.exit(progress$close())

            updateProgress <- function(value = NULL, message = NULL, detail = NULL) {
                progress$set(value = value, message = message, detail = detail)
            }



            prep_out <- prepSC(sc_seq_data,
                input$positionSliderInput[1],
                input$positionSliderInput[2],
                updateProgress = updateProgress
            )
            if (!is.list(prep_out)) {
                shinyjs::showElement("sc_seqPlot")
                shinyjs::toggleElement("sc_seqPlot")
                showNotification("No valid sites in designated range. Choose another gene or adjust
                      start and end positions with a larger range.", duration = 5)
                isolate({
                    actionsLog$log <- c(
                        actionsLog$log,
                        paste("No valid sites for gene ", input$geneList)
                    )
                })
            } else {
                shinyjs::showElement("sc_seqPlot")
                temp_gch <- prep_out$gch

                temp_hcg <- prep_out$hcg
                if (nrow(temp_gch) == nrow(temp_hcg)) {
                    sc_coordinatesObject$refine_start <- 0
                    sc_coordinatesObject$refine_stop <- 0
                    sc_coordinatesObject$weight_start <- 0
                    sc_coordinatesObject$weight_stop <- 0
                    sc_input_data$gch <- temp_gch
                    sc_input_data$hcg <- temp_hcg
                    isolate({
                        actionsLog$log <- c(actionsLog$log, paste("Beginning single-cell data analysis"))
                        actionsLog$log <- c(actionsLog$log, paste(
                            "From position",
                            input$positionSliderInput[1],
                            "to", input$positionSliderInput[2]
                        ))
                    })
                }
            }
        }
    })


    # this object keeps track of the coordinates for refinement and weighting
    sc_coordinatesObject <- reactiveValues(
        refine_start = 0, refine_stop = 0,
        weight_start = 0, weight_stop = 0,
        weight_color = "red"
    )
    # now construct the sc_orderObject
    sc_orderObject <- reactiveValues(toClust = 0, order1 = 0)
    observe({
        if (!is.null(sc_input_data$gch) & !is.null(sc_input_data$hcg)) {
            progress <- Progress$new()
            progress$set(message = "Beginning seriation", value = 0)
            on.exit(progress$close())

            updateProgress <- function(value = NULL, message = NULL, detail = NULL) {
                progress$set(value = value, message = message, detail = detail)
            }

            tempObj <- buildOrderObjectShiny(
                sc_input_data,
                input$sc_ser_method, sc_coordinatesObject,
                updateProgress
            )
            sc_orderObject$order1 <- tempObj$order1
            sc_orderObject$toClust <- tempObj$toClust
            isolate({
                actionsLog$log <- c(
                    actionsLog$log,
                    paste("Ordering with", input$sc_ser_method)
                )
            })
        }
    })

    # this handles updates to sc_coordinatesObject
    observeEvent(input$sc_plot_brush, {
        validate(need(sc_input_data$gch, "Please provide input data"))
        n <- nrow(sc_input_data$gch)
        validate(need(sc_input_data$hcg, "Please provide input data"))
        m <- ncol(sc_input_data$hcg)
        processed_brush <- handleBrushCoordinates(input$sc_plot_brush, n, m)

        if (isolate(input$sc_brush_choice) == "Weighting") {
            sc_coordinatesObject$refine_start <- 0
            sc_coordinatesObject$refine_stop <- 0
            sc_coordinatesObject$weight_start <- processed_brush$first_col
            sc_coordinatesObject$weight_stop <- processed_brush$last_col
            sc_coordinatesObject$weight_color <- processed_brush$weight_color
            isolate({
                actionsLog$log <- c(
                    actionsLog$log,
                    paste(
                        "Weighting", processed_brush$weight_color,
                        "columns",
                        processed_brush$first_col, "to",
                        processed_brush$last_col
                    )
                )
            })
        }
        if (isolate(input$sc_brush_choice) == "Refinement") {
            s <- processed_brush$first_row
            f <- processed_brush$last_row
            if (s != f) {
                sc_coordinatesObject$refine_start <- s
                sc_coordinatesObject$refine_stop <- f
                sc_orderObject$order1 <- refineOrderShiny(isolate(sc_orderObject),
                    refine_method = isolate(input$sc_refine_method),
                    sc_coordinatesObject
                )
                isolate({
                    actionsLog$log <- c(
                        actionsLog$log,
                        paste(
                            "Refining rows",
                            processed_brush$first_row, "to",
                            processed_brush$last_row
                        )
                    )
                    actionsLog$log <- c(
                        actionsLog$log,
                        paste(
                            "Applying refinement with",
                            input$sc_refine_method
                        )
                    )
                })
            }
        }
    })

    observeEvent(input$sc_force_reverse, {
        isolate({
            if (sc_coordinatesObject$refine_start == sc_coordinatesObject$refine_stop) {
                sc_orderObject$order1 <- rev(sc_orderObject$order1)
                actionsLog$log <- c(actionsLog$log, paste(
                    "Reversing rows 1 to",
                    nrow(sc_input_data$gch)
                ))
            } else {
                sc_orderObject$order1[sc_coordinatesObject$refine_start:sc_coordinatesObject$refine_stop] <-
                    sc_orderObject$order1[sc_coordinatesObject$refine_stop:sc_coordinatesObject$refine_start]
                actionsLog$log <- c(
                    actionsLog$log,
                    paste(
                        "Reversing rows", sc_coordinatesObject$refine_start,
                        "to", sc_coordinatesObject$refine_stop
                    )
                )
            }
        })
    })


    observeEvent(input$sc_demo_data, {
        isolate({
            data("singlecell_subset", package = "methylscaper", envir = environment())
            sc_seq_data$gch <- singlecell_subset$gch
            sc_seq_data$hcg <- singlecell_subset$hcg

            showNotification("Data successfully loaded! Please select Mouse
                            under Choose Organism and select a gene (e.g.,
                            Eef1g, Mta2, or Tut1).",
                type = "default", duration = 8
            )
        })
    })


    output$sc_seqPlot <- renderPlot(
        {
            obj <- sc_orderObject
            if (sum(obj$toClust) == 0) {} else drawPlot(obj, isolate(sc_coordinatesObject))
        },
        height = function() {
            session$clientData$output_sc_seqPlot_width * .75
        }
    )


    output$sc_plot_down <- downloadHandler(
        filename = function() {
            if (input$sc_plot_filetype == "PNG") {
                return(paste0("methylscaper_", outname_rds$usename, ".png"))
            }
            if (input$sc_plot_filetype == "PDF") {
                return(paste0("methylscaper_", outname_rds$usename, ".pdf"))
            }
        },
        content = function(file) {
            if (input$sc_plot_filetype == "PNG") png(file)
            if (input$sc_plot_filetype == "PDF") pdf(file)

            drawPlot(sc_orderObject, sc_coordinatesObject,
                drawLines = FALSE, plotFast = FALSE
            )
            dev.off()
        }
    )

    output$sc_log_down <- downloadHandler(
        filename = function() {
            paste0("methylscaper_log_", outname_rds$usename, ".txt")
        },
        content = function(file) {
            fileConn <- file(file)
            writeLines(actionsLog$log, fileConn)
            close(fileConn)
        }
    )

    output$sc_info <- renderText({
        paste0(
            "Refinement selection: ", sc_coordinatesObject$refine_start,
            " ", sc_coordinatesObject$refine_stop, "\n",
            "Weighting selection: ", sc_coordinatesObject$weight_start,
            " ", sc_coordinatesObject$weight_stop
        )
    })

    observe({
        if (sum(sc_orderObject$toClust) == 0) {
            shinyjs::disable("sc_proportion_hist_download")
            shinyjs::disable("sc_proportion_data_download")
            shinyjs::disable("sc_percentC_plot_download")
            shinyjs::disable("sc_percentC_data_download")
            shinyjs::disable("sc_avg_c_plot_download")
            shinyjs::disable("sc_avg_c_data_download")
            shinyjs::disable("sc_plot_down")
            shinyjs::disable("sc_log_down")
        } else {
            shinyjs::enable("sc_proportion_hist_download")
            shinyjs::enable("sc_proportion_data_download")
            shinyjs::enable("sc_percentC_plot_download")
            shinyjs::enable("sc_percentC_data_download")
            shinyjs::enable("sc_avg_c_plot_download")
            shinyjs::enable("sc_avg_c_data_download")
            shinyjs::enable("sc_plot_down")
            shinyjs::enable("sc_log_down")
        }
    })

    output$sc_proportion_color_histogram <- renderPlot({
        obj <- sc_orderObject
        if (sum(obj$toClust) == 0) {} else {
            par(mar = c(5, 4, 2, 2))
            methyl_proportion(obj,
                makePlot = TRUE,
                type = input$sc_proportion_choice, main = "", xlab = "Proportion methylation within cells"
            )
        }
    })

    output$sc_proportion_hist_download <- downloadHandler(
        filename = function() {
            return(paste0("prop_cell_methylated_", tolower(input$sc_proportion_choice), "_", outname_rds$usename, ".pdf"))
        },
        content = function(file) {
            pdf(file)
            methyl_proportion(sc_orderObject,
                makePlot = TRUE,
                type = input$sc_proportion_choice, main = "Methylated Bases Per Cell"
            )
            dev.off()
        }
    )
    output$sc_proportion_data_download <- downloadHandler(
        filename = function() {
            return(paste0("prop_cell_methylated_", tolower(input$sc_proportion_choice), "_", outname_rds$usename, ".csv"))
        },
        content = function(file) {
            dat <- methyl_proportion(sc_orderObject,
                makePlot = FALSE,
                type = input$sc_proportion_choice, main = ""
            )
            write.csv(dat, file = file)
        }
    )

    output$sc_percent_C <- renderPlot({
        if (sum(sc_orderObject$toClust) == 0) {} else {
            par(mar = c(5, 4, 2, 2))
            methyl_percent_sites(sc_orderObject, makePlot = TRUE)
        }
    })

    output$sc_percentC_plot_download <- downloadHandler(
        filename = function() {
            return(paste0("prcnt_bases_methylated_", outname_rds$usename, ".pdf"))
        },
        content = function(file) {
            pdf(file)
            methyl_percent_sites(sc_orderObject, makePlot = TRUE)
            dev.off()
        }
    )

    output$sc_percentC_data_download <- downloadHandler(
        filename = function() {
            return(paste0("prcnt_bases_methylated_", outname_rds$usename, ".txt"))
        },
        content = function(file) {
            dat <- methyl_percent_sites(sc_orderObject, makePlot = FALSE)
            capture.output(dat, file = file)
        }
    )

    output$sc_avg_c <- renderPlot({
        obj <- sc_orderObject
        if (sum(obj$toClust) == 0) {} else {
            par(mar = c(5, 4, 2, 2))
            methyl_average_status(obj, makePlot = TRUE, window_length = input$sc_window_choice)
        }
    })

    output$sc_avg_c_data_download <- downloadHandler(
        filename = function() {
            return(paste0("avg_prcnt_bases_methylated_", outname_rds$usename, ".txt"))
        },
        content = function(file) {
            dat <- methyl_average_status(sc_orderObject, makePlot = FALSE, window_length = input$sc_window_choice)
            capture.output(dat, file = file)
        }
    )

    output$sc_avg_c_plot_download <- downloadHandler(
        filename = function() {
            return(paste0("avg_prcnt_bases_methylated_", outname_rds$usename, ".pdf"))
        },
        content = function(file) {
            pdf(file)
            methyl_average_status(sc_orderObject, makePlot = TRUE, window_length = input$sc_window_choice)
            dev.off()
        }
    )



    ########################
    # Single-molecule data #
    ########################
    sm_input_data <- reactiveValues(gch = NULL, hcg = NULL)
    sm_raw_data <- reactiveValues(gch = NULL, hcg = NULL)


    observe({
        if (input$seriate_sm == "Preprocessing" & input$big_tab == "Single-molecule") {
            showNotification("Please provide reference and FASTA files to begin",
                type = "message", duration = 4
            )
        }
        if (input$seriate_sm == "Visualization" & input$big_tab == "Single-molecule") {
            showNotification("Provide select the RDS file to begin",
                type = "message", duration = 4
            )
        }
    })

    # alignment handling
    observeEvent(input$run_align, {
        validate(
            need(input$ref_file$datapath, "Please provide the reference .fasta file."),
            need(input$fasta_file$datapath, "Please provide the reads .fasta file.")
        )

        ref <- tryCatch(read.fasta(input$ref_file$datapath),
            error = function(cond) {
                message(paste("Please check the format of your .fasta file"))
                # Choose a return value in case of error
                return(NA)
            }
        )
        if (!is.list(ref)) {
            showNotification("Please check the format of your reference .fasta file",
                type = "error", duration = 4
            )
        }


        fasta <- tryCatch(read.fasta(input$fasta_file$datapath),
            error = function(cond) {
                message(paste("Please check the format of your .fasta file"))
                # Choose a return value in case of error
                return(NA)
            }
        )
        if (!is.list(fasta)) {
            showNotification("Please check the format of your reads .fasta file",
                type = "error", duration = 4
            )
        }

        if (is.list(ref) & is.list(fasta)) {
            if (length(ref) == 1) {
                ref <- ref[[1]]
            }

            progress <- Progress$new()
            progress$set(message = "Beginning alignment", value = 0)
            on.exit(progress$close())

            updateProgress <- function(value = NULL, message = NULL, detail = NULL) {
                progress$set(value = value, message = message, detail = detail)
            }

            align_out <- tryCatch(
                runAlign(ref, fasta,
                    updateProgress = updateProgress,
                    log_file = input$processing_log_name
                ),
                error = function(cond) {
                    message(paste("No good alignments were found."))
                    # Choose a return value in case of error
                    return(NA)
                }
            )

            if (!is.list(align_out)) {
                showNotification("No good alignments were found.",
                    type = "error", duration = 4
                )
            }
            if (is.list(align_out)) {
                sm_raw_data$gch <- align_out$gch
                sm_raw_data$hcg <- align_out$hcg
                sm_raw_data$log_vector <- align_out$logs
            }
            read_name <- tools::file_path_sans_ext(input$fasta_file$name)
            ref_name <- tools::file_path_sans_ext(input$ref_file$name)
            outname$usename <- paste0(read_name, "_", ref_name)
        }
    })

    observe({
        if (is.null(sm_raw_data$hcg)) {
            shinyjs::disable("sm_preprocessing_down")
            shinyjs::disable("processing_log")
        } else {
            shinyjs::enable("sm_preprocessing_down")
            shinyjs::enable("processing_log")
        }
    })


    output$sm_preprocessing_down <- downloadHandler(
        filename = function() {
            paste0(outname$usename, ".rds")
        },
        content = function(file) {
            saveRDS(list(gch = sm_raw_data$gch, hcg = sm_raw_data$hcg), file = file)
        }
    )

    output$processing_log <- downloadHandler(
        filename = function() {
            paste0("Preprocessing_log_", outname$usename, ".txt")
        },
        content = function(file) {
            writeLines(sm_raw_data$log_vector, con = file)
        }
    )

    observe({
        if (!is.null(input$sm_rds_file)) {
            temp <- readRDS(file = input$sm_rds_file$datapath)
            temp_gch <- temp$gch
            temp_hcg <- temp$hcg
            outname_rds$usename <- tools::file_path_sans_ext(input$sm_rds_file$name)
            if (all(rownames(temp_hcg) == temp_hcg[, 1])) temp_hcg <- temp_hcg[, -1]
            if (all(rownames(temp_gch) == temp_gch[, 1])) temp_gch <- temp_gch[, -1]

            if (nrow(temp_gch) == nrow(temp_hcg)) {
                sm_coordinatesObject$refine_start <- 0
                sm_coordinatesObject$refine_stop <- 0
                sm_coordinatesObject$weight_start <- 0
                sm_coordinatesObject$weight_stop <- 0
                sm_input_data$gch <- temp_gch
                sm_input_data$hcg <- temp_hcg
                sm_input_data$datatype <- "sm"
                isolate({
                    actionsLog$log <- c(actionsLog$log, paste("Beginning
            single-molecule data analysis"))
                    actionsLog$log <- c(actionsLog$log, paste(
                        "Loading data:",
                        input$sm_rds_file$name
                    ))
                })
            }
        }
    })

    # this object keeps track of the coordinates for refinement and weighting
    sm_coordinatesObject <- reactiveValues(
        refine_start = 0, refine_stop = 0,
        weight_start = 0, weight_stop = 0,
        weight_color = "red"
    )
    # now construct the sm_orderObject
    sm_orderObject <- reactiveValues(toClust = 0, order1 = 0)
    observe({
        if (!is.null(sm_input_data$gch) & !is.null(sm_input_data$hcg)) {
            progress <- Progress$new()
            progress$set(message = "Beginning seriation", value = 0)
            on.exit(progress$close())

            updateProgress <- function(value = NULL, message = NULL, detail = NULL) {
                progress$set(value = value, message = message, detail = detail)
            }

            tempObj <- buildOrderObjectShiny(
                sm_input_data,
                input$sm_ser_method, sm_coordinatesObject, updateProgress
            )
            sm_orderObject$order1 <- tempObj$order1
            sm_orderObject$toClust <- tempObj$toClust
            isolate({
                actionsLog$log <- c(
                    actionsLog$log,
                    paste("Ordering with", input$sm_ser_method)
                )
            })
        }
    })

    # this handles updates to sm_coordinatesObject
    observeEvent(input$sm_plot_brush, {
        validate(need(sm_input_data$gch, "Please provide input data"))
        validate(need(sm_input_data$hcg, "Please provide input data"))
        n <- nrow(sm_input_data$gch)
        m <- ncol(sm_input_data$hcg)
        processed_brush <- handleBrushCoordinates(input$sm_plot_brush, n, m)

        if (isolate(input$sm_brush_choice) == "Weighting") {
            sm_coordinatesObject$refine_start <- 0
            sm_coordinatesObject$refine_stop <- 0
            sm_coordinatesObject$weight_start <- processed_brush$first_col
            sm_coordinatesObject$weight_stop <- processed_brush$last_col
            sm_coordinatesObject$weight_color <- processed_brush$weight_color
            isolate({
                actionsLog$log <- c(
                    actionsLog$log,
                    paste(
                        "Weighting",
                        processed_brush$weight_color, "columns",
                        processed_brush$first_col, "to",
                        processed_brush$last_col
                    )
                )
            })
        }
        if (isolate(input$sm_brush_choice) == "Refinement") {
            s <- processed_brush$first_row
            f <- processed_brush$last_row
            if (s != f) {
                sm_coordinatesObject$refine_start <- s
                sm_coordinatesObject$refine_stop <- f
                sm_orderObject$order1 <- refineOrderShiny(isolate(sm_orderObject),
                    refine_method = isolate(input$sm_refine_method),
                    sm_coordinatesObject
                )
                isolate({
                    actionsLog$log <- c(
                        actionsLog$log,
                        paste(
                            "Refining rows",
                            processed_brush$first_row, "to",
                            processed_brush$last_row
                        )
                    )
                    actionsLog$log <- c(
                        actionsLog$log,
                        paste(
                            "Applying refinement with",
                            input$sm_refine_method
                        )
                    )
                })
            }
        }
    })

    observeEvent(input$sm_force_reverse, {
        isolate({
            if (sm_coordinatesObject$refine_start == sm_coordinatesObject$refine_stop) {
                sm_orderObject$order1 <- rev(sm_orderObject$order1)
                actionsLog$log <- c(actionsLog$log, paste(
                    "Reversing rows 1 to",
                    nrow(sm_input_data$gch)
                ))
            } else {
                sm_orderObject$order1[sm_coordinatesObject$refine_start:sm_coordinatesObject$refine_stop] <-
                    sm_orderObject$order1[sm_coordinatesObject$refine_stop:sm_coordinatesObject$refine_start]
                actionsLog$log <- c(
                    actionsLog$log,
                    paste(
                        "Reversing rows", sm_coordinatesObject$refine_start,
                        "to", sm_coordinatesObject$refine_stop
                    )
                )
            }
        })
    })

    observeEvent(input$sm_demo_data, {
        isolate({
            data("singlemolecule_example", package = "methylscaper", envir = environment())
            sm_input_data$gch <- singlemolecule_example$gch
            sm_input_data$hcg <- singlemolecule_example$hcg
        })
    })


    output$sm_seqPlot <- renderPlot(
        {
            obj <- sm_orderObject
            if (sum(obj$toClust) == 0) {} else {
                sz <- session$clientData$output_sm_seqPlot_width
                drawPlot(obj, isolate(sm_coordinatesObject), shinySizer = sz)
            }
        },
        height = function() {
            session$clientData$output_sm_seqPlot_width
        }
    )



    output$sm_plot_down <- downloadHandler(
        filename = function() {
            if (input$sm_filetype == "PNG") {
                return(paste0("methylscaper_", outname_rds$usename, ".png"))
            }
            if (input$sm_filetype == "PDF") {
                return(paste0("methylscaper_", outname_rds$usename, ".pdf"))
            }
        },
        content = function(file) {
            if (input$sm_filetype == "PNG") png(file)
            if (input$sm_filetype == "PDF") pdf(file)

            drawPlot(sm_orderObject, sm_coordinatesObject,
                drawLines = FALSE, plotFast = FALSE
            )
            dev.off()
        }
    )

    output$sm_log_down <- downloadHandler(
        filename = function() {
            paste0("methylscaper_log_", outname_rds$usename, ".txt")
        },
        content = function(file) {
            fileConn <- file(file)
            writeLines(actionsLog$log, fileConn)
            close(fileConn)
        }
    )

    output$sm_info <- renderText({
        paste0(
            "Refinement selection: ", sm_coordinatesObject$refine_start, " ",
            sm_coordinatesObject$refine_stop, "\n",
            "Weighting selection: ", sm_coordinatesObject$weight_start, " ",
            sm_coordinatesObject$weight_stop
        )
    })


    observe({
        if (sum(sm_orderObject$toClust) == 0) {
            shinyjs::disable("sm_proportion_hist_download")
            shinyjs::disable("sm_proportion_data_download")
            shinyjs::disable("sm_percentC_plot_download")
            shinyjs::disable("sm_percentC_data_download")
            shinyjs::disable("sm_avg_c_plot_download")
            shinyjs::disable("sm_avg_c_data_download")
            shinyjs::disable("sm_plot_down")
            shinyjs::disable("sm_log_down")
        } else {
            shinyjs::enable("sm_proportion_hist_download")
            shinyjs::enable("sm_proportion_data_download")
            shinyjs::enable("sm_percentC_plot_download")
            shinyjs::enable("sm_percentC_data_download")
            shinyjs::enable("sm_avg_c_plot_download")
            shinyjs::enable("sm_avg_c_data_download")
            shinyjs::enable("sm_plot_down")
            shinyjs::enable("sm_log_down")
        }
    })


    output$sm_proportion_color_histogram <- renderPlot({
        obj <- sm_orderObject
        if (sum(obj$toClust) == 0) {} else {
            par(mar = c(5, 4, 2, 2))
            methyl_proportion(obj,
                makePlot = TRUE,
                type = input$sm_proportion_choice, main = "", xlab = "Proportion methylation within molecules"
            )
        }
    })

    output$sm_proportion_hist_download <- downloadHandler(
        filename = function() {
            if (input$sm_proportion_choice == "Accessibility Methylation") {
                whichMeth <- "acc"
            } else {
                whichMeth <- "met"
            }
            return(paste0("prop_molecule_methylated_", whichMeth, "_", outname_rds$usename, ".pdf"))
        },
        content = function(file) {
            pdf(file)
            methyl_proportion(sm_orderObject,
                makePlot = TRUE,
                type = input$sm_proportion_choice, main = "Methylated Bases Per Molecule"
            )
            dev.off()
        }
    )
    output$sm_proportion_data_download <- downloadHandler(
        filename = function() {
            if (input$sm_proportion_choice == "Accessibility Methylation") {
                whichMeth <- "acc"
            } else {
                whichMeth <- "met"
            }
            return(paste0("prop_molecule_methylated_", whichMeth, "_", outname_rds$usename, ".csv"))
        },
        content = function(file) {
            dat <- methyl_proportion(sm_orderObject,
                makePlot = FALSE,
                type = input$sm_proportion_choice, main = "Methylated Basepairs Per Molecule"
            )
            write.csv(dat, file = file)
        }
    )

    output$sm_percent_C <- renderPlot({
        obj <- sm_orderObject
        if (sum(obj$toClust) == 0) {} else {
            par(mar = c(5, 4, 2, 2))
            methyl_percent_sites(obj, makePlot = TRUE)
        }
    })

    output$sm_percentC_plot_download <- downloadHandler(
        filename = function() {
            return(paste0("prcnt_bases_methylated_", outname_rds$usename, ".pdf"))
        },
        content = function(file) {
            pdf(file)
            methyl_percent_sites(sm_orderObject, makePlot = TRUE)
            dev.off()
        }
    )

    output$sm_percentC_data_download <- downloadHandler(
        filename = function() {
            return(paste0("prcnt_bases_methylated_", outname_rds$usename, ".txt"))
        },
        content = function(file) {
            dat <- methyl_percent_sites(sm_orderObject, makePlot = FALSE)
            capture.output(dat, file = file)
        }
    )

    output$sm_avg_c <- renderPlot({
        obj <- sm_orderObject
        if (sum(obj$toClust) == 0) {} else {
            par(mar = c(5, 4, 2, 2))
            methyl_average_status(obj, makePlot = TRUE, window_length = input$sm_window_choice)
        }
    })

    output$sm_avg_c_data_download <- downloadHandler(
        filename = function() {
            return(paste0("avg_prcnt_bases_methylated_", outname_rds$usename, ".txt"))
        },
        content = function(file) {
            dat <- methyl_average_status(sm_orderObject, makePlot = FALSE, window_length = input$sm_window_choice)
            capture.output(dat, file = file)
        }
    )

    output$sm_avg_c_plot_download <- downloadHandler(
        filename = function() {
            return(paste0("avg_prcnt_bases_methylated_", outname_rds$usename, ".pdf"))
        },
        content = function(file) {
            pdf(file)
            methyl_average_status(sm_orderObject, makePlot = TRUE, window_length = input$sm_window_choice)
            dev.off()
        }
    )
}

#' Process single-cell data
#'
#' This function subsets the data and prepares it for visualizing by
#' generating representation methylation-state matrices from
#' single-cell methylation data (for example, sc-MNT data).
#' We assume the data has already been preprocess using the subsetSC
#' function in methylscaper. See the vignette for a more thorough
#' explanation of each parameter. The output should be passed directly to the
#' plotting function.
#'
#' @param dataIn A list object containing two elements labelled gch and hcg (already pre-processed.)
#' @param startPos The index of the first position to include
#'  in the visualization. If using this within the R console it is
#'  recomended to specify the start and end directly.
#'  In the Shiny app, a slider will let the user refine these positions.
#' @param endPos The index of the final position to include in the visualization.
#' @param updateProgress A function for generating progress bars in the Shiny app.
#'   Should be left NULL otherwise.
#' @return The output is a list containing the elements 'gch' and 'hcg.
#'      Each is a dataframe with reads/cells on the rows and each column
#'      is a base-pair. The matrix is coded as follows:
#'          -2: unmethylated GCH or HCG site
#'          -1: base pairs between two unmethylated GCH or HCG sites
#'          0: base pairs between mismatching methylation states of
#'              two GCH or HCG sites
#'          1: base pairs between two methylated GCH or HCG sites
#'          2: methylated GCH or HCG site
#' @importFrom utils tail
#' @import data.table
#' @importFrom methods is
#' @export
#' @examples
#'
#' data(singlecell_subset)
#' prepsc.out <- prepSC(singlecell_subset,
#'     startPos = 105636488, endPos = 105636993
#' )
prepSC <- function(
        dataIn, startPos = NULL, endPos = NULL,
        updateProgress = NULL) {
    if (is(dataIn, "SummarizedExperiment") | is(dataIn, "SingleCellExperiment")) {
        dataIn <- reformatSCE(dataIn)
    }

    if (is.null(updateProgress) & (endPos - startPos) >= 50000) {
        message("Selected range is longer than 50k bp,
                    plot may take a few seconds to render.")
    }

    if (is.null(updateProgress) & (endPos - startPos) >= 100000) {
        message("Selected range is longer than 100k bp,
                    this may not be optimal.
                    Plot will render but may take a few minutes.")
    }

    gc_seq_data <- dataIn$gch
    cg_seq_data <- dataIn$hcg
    if (is.function(updateProgress)) {
        updateProgress(message = "Filtering HCG (endogenous methylation)
                                    site data", value = 0.1)
    }

    cg_seq_sub <- lapply(cg_seq_data, function(x) {
        tempSub <- x[order(x$pos), ]
        tempSub <- subset(tempSub, tempSub$pos >= startPos & tempSub$pos <= endPos)
        return(tempSub)
    })

    if (is.function(updateProgress)) {
        updateProgress(message = "Filtering GCH (accessibility/occupancy) site data", value = 0.5)
    }


    gc_seq_sub <- lapply(gc_seq_data, function(x) {
        tempSub <- x[order(x$pos), ]
        tempSub <- subset(tempSub, tempSub$pos >= startPos & tempSub$pos <= endPos)
        return(tempSub)
    })

    all_cg_sites <- unique(do.call(c, cg_seq_sub))
    all_gc_sites <- unique(do.call(c, gc_seq_sub))
    useseq <- intersect(
        which(vapply(cg_seq_sub, function(x) nrow(x), numeric(1)) > 1),
        which(vapply(gc_seq_sub, function(x) nrow(x), numeric(1)) > 1)
    )

    if (length(useseq) == 0) {
        return(NULL)
    }

    cg_seq_sub <- cg_seq_sub[useseq]
    gc_seq_sub <- gc_seq_sub[useseq]

    if (is.function(updateProgress)) {
        updateProgress(message = "Mapping HCG (endogenous methylation) site data", value = 0.75)
    }

    cg_outseq <- lapply(cg_seq_sub, function(x) {
        if (nrow(x) == 0) {
            NULL
        } else {
            mapSC(x, startPos, endPos)
        }
    })

    cg_outseq <- cg_outseq[!vapply(cg_outseq, is.null, logical(1))]
    hcg <- data.matrix(do.call(rbind, cg_outseq))
    rownames(hcg) <- as.character(seq(1, nrow(hcg)))

    if (is.function(updateProgress)) {
        updateProgress(message = "Mapping GCH (accessibility/occupancy) site data", value = 0.9)
    }

    gc_outseq <- lapply(gc_seq_sub, function(x) {
        if (nrow(x) == 0) {
            NULL
        } else {
            mapSC(x, startPos, endPos)
        }
    })

    gc_outseq <- gc_outseq[!vapply(gc_outseq, is.null, logical(1))]
    gch <- data.matrix(do.call(rbind, gc_outseq))
    rownames(gch) <- as.character(seq(1, nrow(gch)))

    return(list(gch = gch, hcg = hcg))
}

mapSC <- function(inSeq, startPos, endPos) {
    inSeq$basePos <- as.numeric(inSeq$pos) - startPos + 1
    fill_1 <- seq(startPos, endPos) - startPos + 1
    someMethyl <- which(inSeq$rate > 0)
    noMethyl <- which(inSeq$rate <= 0)
    fill_1[fill_1 %in% inSeq[someMethyl, ]$basePos] <- 2
    fill_1[fill_1 %in% inSeq[noMethyl, ]$basePos] <- -2
    fill_1[abs(fill_1) != 2] <- "."

    sites <- inSeq$basePos
    sites <- sites[sites > 0]
    editseq <- fill_1
    sites_temp <- c(0, sites, max(sites) + 1)

    for (j in seq(1, (length(sites_temp) - 1))) {
        if (sites_temp[j + 1] == 1) { # skip
        } else {
            tofill <- seq(sites_temp[j] + 1, (sites_temp[j + 1] - 1))
            s1 <- editseq[pmax(1, sites_temp[j])]
            s2 <- editseq[pmin(length(editseq), sites_temp[j + 1])]

            if (s1 == "2" & s2 == "2") {
                fillvec <- 1
            } else if (s1 == "2" & s2 == "-2") {
                fillvec <- 0
            } else if (s1 == "-2" & s2 == "2") {
                fillvec <- 0
            } else if (s1 == "-2" & s2 == "-2") {
                fillvec <- -1
            } else {
                fillvec <- 0
            }
            fillvec <- rep(fillvec, length(tofill))
            editseq[tofill] <- fillvec
        }
    }
    return(editseq)
}



#' Load in methylation data
#'
#' This function loads the single-cell files. It takes a path to the data files
#' and a chromosome number as arguments and returns the desired subset of the
#' data. Processing by chromosome is important for speed and memory efficiency.
#' The input files should be tab separated with three columns.
#' The first column is the chromosome, the second is the position (basepair), and the third
#' is the methylation indicator/rate. The folder should contain two subfolders titled
#' met and acc, with the endogenous methylation and accessibility methylation files,
#' respectively.
#'
#' @param path Path to the folder containing the single-cell files.
#' @param chromosome The chromosome to subset the files to.
#' @param startPos The index of the first position to include
#'  in the subsetting. This is optional as further narrowing of the
#'  position can be done in the visualization step/tab.
#'  In the Shiny app, a slider will let the user refine the positions.
#' @param endPos The index of the final position to include in subset.
#' @param updateProgress A function for generating progress bars in the Shiny app.
#'   Should be left NULL otherwise.
#' @return The output is RDS files that can be loaded into the visualization
#'  tab on the Shiny app
#' @import data.table
#' @export
#'
#' @examples
#' # example not run since needs directory input from user
#' # subsc.out <- subsetSC("filepath", chromosome=19)
subsetSC <- function(
        path, chromosome, startPos = NULL,
        endPos = NULL, updateProgress = NULL) {
    if (!is.list(path)) {
        cgfiles <- paste0(path, "/", "met/", sort(grep("met", list.files(paste0(path, "/met")), value = TRUE)))
        gcfiles <- paste0(path, "/", "acc/", sort(grep("acc", list.files(paste0(path, "/acc")), value = TRUE)))
    } else {
        cgfiles <- path[[1]]
        gcfiles <- path[[2]]

        getord <- order(path[[3]])
        cgfiles <- cgfiles[getord]

        getord <- order(path[[4]])
        gcfiles <- gcfiles[getord]
    }


    if (length(cgfiles) != length(gcfiles)) {
        stop("Must have the same number of methylation and
                accessibility files!")
    }

    useChr <- chromosome

    cg_seq <- list()
    for (i in seq(1, length(cgfiles))) {
        in_cg_seq <- fread(cgfiles[i],
            header = FALSE, stringsAsFactors = FALSE
        )
        # A couple possible formats from bismark:
        if (ncol(in_cg_seq) %in% c(4, 6)) {
            in_cg_seq <- in_cg_seq[, c(1, 2, 4)]
        }

        if (ncol(in_cg_seq) != 3) {
            stop("Data is not formatted correctly. See vignette for details.")
        }

        if (in_cg_seq[1, 1] == "chr") {
            in_cg_seq <- in_cg_seq[-1, ]
        }
        colnames(in_cg_seq) <- c("chr", "pos", "rate")
        in_cg_seq$pos <- as.numeric(in_cg_seq$pos)
        in_cg_seq$rate <- as.numeric(in_cg_seq$rate)

        in_cg_seq <- subset(in_cg_seq, in_cg_seq$chr == useChr)
        if (!is.null(startPos) & !is.null(endPos)) {
            in_cg_seq <- subset(in_cg_seq, in_cg_seq$pos >= startPos & in_cg_seq$pos <= endPos)
        }

        cg_seq[[i]] <- in_cg_seq
        if (is.function(updateProgress)) {
            updateProgress(message = "Reading HCG (endogenous methylation) site files", value = i / length(cgfiles))
        }
    }

    gc_seq <- list()
    for (i in seq(1, length(gcfiles))) {
        in_gc_seq <- fread(gcfiles[i], header = FALSE, stringsAsFactors = FALSE)
        if (ncol(in_gc_seq) %in% c(4, 6)) {
            in_gc_seq <- in_gc_seq[, c(1, 2, 4)]
        }
        if (ncol(in_gc_seq) != 3) {
            stop("Data is not formatted correctly. See vignette for details.")
        }

        colnames(in_gc_seq) <- c("chr", "pos", "rate")
        if (in_gc_seq[1, 1] == "chr") {
            in_gc_seq <- in_gc_seq[-1, ]
        }
        colnames(in_gc_seq) <- c("chr", "pos", "rate")
        in_gc_seq$pos <- as.numeric(in_gc_seq$pos)
        in_gc_seq$rate <- as.numeric(in_gc_seq$rate)

        in_gc_seq <- subset(in_gc_seq, in_gc_seq$chr == useChr)
        if (!is.null(startPos) & !is.null(endPos)) {
            in_gc_seq <- subset(in_gc_seq, in_gc_seq$pos >= startPos & in_gc_seq$pos <= endPos)
        }

        gc_seq[[i]] <- in_gc_seq
        if (is.function(updateProgress)) {
            updateProgress(message = "Reading GCH (accessibility/occupancy) site files", value = i / length(gcfiles))
        }
    }

    list(hcg = cg_seq, gch = gc_seq)
}

#' This is an internal function for now and a place-holder
#' in case SingleCellExperiment may be
#' used in the future. We may need to update this later. Assumes
#' rownames are formatted like chr_pos and there are two assays.
#' The assay names are `methylation_met` for endogenous methylation
#' and `methylation_acc` for accessibility.
#' @param dataIn Input SCE object passed to the prepSC() function.
#' @return List object containing the met and acc tables.
#' @importFrom SummarizedExperiment assay
reformatSCE <- function(dataIn) {
    check_package("SingleCellExperiment")
    check_package("SummarizedExperiment")

    dataOut.gch <- assay(dataIn, "methylation_acc")
    locs_list <- rownames(dataOut.gch)
    locs_list <- data.frame(do.call(rbind, strsplit(locs_list, "_")))
    colnames(locs_list) <- c("chr", "pos")
    locs_list$pos <- as.numeric(locs_list$pos)
    dataOut.gch.list <- split(dataOut.gch, rep(seq(1, ncol(dataOut.gch)), each = nrow(dataOut.gch)))


    dataOut.hcg <- assay(dataIn, "methylation_met")
    locs_list <- rownames(dataOut.hcg)
    locs_list <- data.frame(do.call(rbind, strsplit(locs_list, "_")))
    colnames(locs_list) <- c("chr", "pos")
    locs_list$pos <- as.numeric(locs_list$pos)
    dataOut.hcg.list <- split(dataOut.hcg, rep(seq(1, ncol(dataOut.hcg)), each = nrow(dataOut.hcg)))
    # dataOut.hcg.list <- lapply(dataOut.hcg.list, function(x) GRanges(seqnames = locs_list$chr,
    #                                         ranges = IRanges(start = locs_list$pos, width = 1L),
    #                                         rate=x))

    return(list(gch = dataOut.gch.list, hcg = dataOut.hcg.list))
}


#' Check if a package is installed
#' @param package Name of the package.
#' @return Message is returned if package not installed.
check_package <- function(package) {
    suppressMessages({
        if (!requireNamespace(package, quietly = TRUE)) {
            stop(package, " package is needed, please install it.")
        }
    })
}

ui <- navbarPage("methylscaper",
    id = "big_tab",
    tabPanel(
        "Single-cell",
        navbarPage("",
            id = "seriate_sc",
            tabPanel(
                "Preprocessing",
                fluidRow(
                    column(
                        4,
                        tags$br(),
                        tags$br(),
                        fileInput("sc_met_files", label = "Endogenous Methylation Files", multiple = TRUE),
                        fileInput("sc_acc_files", label = "Accessibility Methylation Files", multiple = TRUE),
                        textInput("chromosome_number", "Chromosome number"),
                        actionButton("run_subset", label = "Run"),
                    ),
                    column(6,
                        offset = 1,
                        tags$h3("Directions"),
                        tags$ul(
                            tags$li("Select all methylation files of each type when uploading data from the single-cell experiment. This summarized data
                                should be from Bismark's methylation extractor or in the form of three columns (chromosome, position, methylation rate)."),
                            tags$li("As these files are large, we process a single chromosome at a time.
                                    Indicate the desired chromosome as a number (e.g., 1 - 22) or as X, Y, MT."),
                            tags$li("After pressing 'Run', a progress bar will appear in the bottom right.")
                        ),
                        tags$br(),
                        tags$p("After processing and subsetting the data for visualization, you may download the data below.
                                The data will be downloaded in RDS format and can be loaded into the Visualization tab."),
                        shinyjs::disabled(downloadButton("sc_preprocessing_down", label = "Download Processed Data"))
                    )
                ),
                tags$br(),
                tags$br(),
                fluidRow(
                    tags$p(
                        "For additional information or to view Frequently Asked Questions, see the ",
                        tags$a(href = "http://bioconductor.org/packages/devel/bioc/vignettes/methylscaper/inst/doc/methylScaper.html", "methylscaper
                vignette.")
                    ),
                    tags$p(
                        "Questions can also be submitted on our GitHub page:",
                        tags$a(href = "https://github.com/rhondabacher/methylscaper/issues", "Report issue/bug")
                    )
                )
            ),
            tabPanel(
                "Visualization",
                fluidRow(
                    column(
                        11,
                        tags$p("Upload the RDS file obtained in the Preprocessing tab below in the input labelled
                         'RDS File Input'. Alternatively, explore the app by selecting 'Load Example Data' below. The example data
                         is from Mouse on Chromosome 19 subset to a 40 kbp region around 8,967,041. Some genes that are located in this region
                         are", tags$em("Eef1g,"), tags$em("Mta2,"), "and", tags$em("Tut1.")),
                        tags$p("To move along the genome, we have pre-loaded gene locations for Human (GRCh38) and Mouse (GRCm39)
                         for the chromosome selected in the Preprocessing tab. Select a gene and then a slider will appear
                         to refine the genomic location."),
                        tags$p("With Brushing set to Weighting, drag the mouse/cursor to select basepairs (columns)
                         on which to weight the ordering algorithm. Once the weighting is set, change Brushing to
                         refinement and highlight the cells (rows) to refine the ordering."),
                        tags$p(
                            "Detailed descriptions of the various options for seriation, weighting, and refinement are in the ",
                            tags$a(href = "http://bioconductor.org/packages/devel/bioc/vignettes/methylscaper/inst/doc/methylScaper.html", "methylscaper
                         vignette.")
                        )
                    )
                ),
                fluidRow(sidebarLayout(
                    sidebarPanel(
                        actionButton("sc_demo_data", label = "Load Example Data", style = "background-color: rgb(209, 238, 238)"),
                        tags$br(),
                        tags$br(),
                        fileInput("sc_rds_file", label = "RDS File Input"),
                        radioButtons("organism_choice",
                            label = "Choose Organism:", choices = c("Human", "Mouse", "Other"),
                            selected = character(0)
                        ),
                        selectizeInput("geneList",
                            label = "Choose Gene", choices = NULL,
                            options = list(
                                placeholder = "Begin typing or select from below",
                                onInitialize = I('function() { this.setValue(""); }')
                            )
                        ),
                        uiOutput("startPos"),
                        uiOutput("endPos"),
                        uiOutput("positionSlider"),
                        selectInput("sc_ser_method",
                            label = "Seriation Method:",
                            choices = c("PCA", "ARSA")
                        ),
                        selectInput("sc_refine_method",
                            label = "Refinement Method:",
                            choices = c("PCA", "HC_average")
                        ),
                        radioButtons("sc_brush_choice",
                            label = "Brushing for:",
                            choices = c("Refinement", "Weighting"), selected = "Weighting"
                        ),
                        actionButton("sc_force_reverse", label = "Reverse Current Ordering"),
                        verbatimTextOutput("sc_info"),
                        width = 3
                    ),
                    mainPanel(
                        fluidRow(
                            column(
                                width = 10,
                                shinyjs::useShinyjs(),
                                plotOutput(outputId = "sc_seqPlot", brush = "sc_plot_brush", width = "100%")
                            ),
                            column(
                                width = 2, align = "left",
                                selectInput("sc_plot_filetype", label = "Choose file type for saving heatmap", choices = c("PDF", "PNG", "SVG", "SVGZ")),
                                numericInput("sc_height", label = "Height (inches):", value = 7),
                                numericInput("sc_width", label = "Width (inches):", value = 7),
                                numericInput("sc_res", label = "Resolution for PNG (ppi):", value = 300),
                                shinyjs::disabled(downloadButton("sc_plot_down", label = "Download Heatmap")),
                                shinyjs::disabled(downloadButton("sc_log_down", label = "Download Ordering Log"))
                            )
                        )
                    )
                ))
            ),
            tabPanel(
                "Summary Statistics",
                fluidRow(
                    column(
                        10,
                        tags$p("Below are summary plots of the methylation data. The histogram on the left
                        calulates the proportion of methylated bases within each cell. Choose whether to calculate this for
                        the endogenous methylation or the accessibility methylation. The plot in the middle calculates the percent of
                        cells having methylation at each GCH (yellow) or HCG (red) site in the region. The plot on the right calculates
                        a population averaged methylation status over the entire region. The window size can be adjusted. This plot
                        is similar to the one in the middle but is easier to interpret when the region is large.")
                    )
                ),
                fluidRow(
                    column(10, radioButtons("sc_proportion_choice",
                        label = "Proportion of:",
                        choices = c("Accessibility Methylation", "Endogenous Methylation"), selected = "Accessibility Methylation"
                    )),
                    column(2, numericInput("sc_window_choice",
                        label = "Window size:",
                        value = 20
                    ))
                ),
                fluidRow(
                    splitLayout(
                        cellWidths = c("33%"),
                        plotOutput(outputId = "sc_proportion_color_histogram"),
                        plotOutput(outputId = "sc_percent_C"),
                        plotOutput(outputId = "sc_avg_c")
                    ),
                    splitLayout(
                        cellWidths = c("33%"),
                        shinyjs::disabled(downloadButton("sc_proportion_hist_download", label = "Download Histogram")),
                        shinyjs::disabled(downloadButton("sc_percentC_plot_download", label = "Download Plot")),
                        shinyjs::disabled(downloadButton("sc_avg_c_plot_download", label = "Download Plot"))
                    ),
                    splitLayout(
                        cellWidths = c("33%"),
                        shinyjs::disabled(downloadButton("sc_proportion_data_download", label = "Download Proportion Data")),
                        shinyjs::disabled(downloadButton("sc_percentC_data_download", label = "Download Percentage Data")),
                        shinyjs::disabled(downloadButton("sc_avg_c_data_download", label = "Download Averaged Percent Data"))
                    )
                )
            )
        )
    ),
    tabPanel(
        "Single-molecule",
        navbarPage("",
            id = "seriate_sm",
            tabPanel(
                "Preprocessing",
                fluidRow(
                    column(
                        3,
                        tags$br(),
                        tags$br(),
                        fileInput("fasta_file", label = "Reads .FASTA File", accept = c(".fa", ".txt", ".fasta"), multiple = TRUE),
                        fileInput("ref_file", label = "Reference .FASTA File", accept = c(".fa", ".txt", ".fasta"), multiple = TRUE),
                        actionButton("run_align", label = "Run"),
                    ),
                    column(6,
                        offset = 1,
                        tags$h3("Directions"),
                        tags$ul(
                            tags$li("Upload the reads or sequences from the single-molecule experiment in FASTA format in the input labelled
                                'FASTA File'. There is a 10MB upload limit for files on the webserver. For larger files,
                                please run methylscaper locally. Additional details are provided in the vignette linked at the bottom of this page."),
                            tags$li("Upload the reference sequence for the gene or genomic location of interest in the input
                                labelled 'Reference File', this should also be in FASTA format."),
                            tags$li("After pressing 'Run', a progress bar will appear in the bottom right.")
                        ),
                        tags$br(),
                        tags$p("After aligining and processing the reads for visualization, you may download the data and the
                    preprocessing log below. The data will be downloaded in RDS format and can be loaded into the Visualization tab.
                    The processing log contains details on the read alignments."),
                        shinyjs::disabled(downloadButton("sm_preprocessing_down", label = "Download Processed Data")),
                        shinyjs::disabled(downloadButton("processing_log", label = "Download Log File"))
                    )
                ),
                tags$br(),
                tags$br(),
                fluidRow(
                    tags$p(
                        "For additional information or to view Frequently Asked Questions, see the ",
                        tags$a(href = "http://bioconductor.org/packages/devel/bioc/vignettes/methylscaper/inst/doc/methylScaper.html", "methylscaper
                vignette.")
                    ),
                    tags$p(
                        "Questions can also be submitted on our GitHub page:",
                        tags$a(href = "https://github.com/rhondabacher/methylscaper/issues", "Report issue/bug")
                    )
                )
            ),
            tabPanel(
                "Visualization",
                fluidRow(
                    column(
                        11,
                        tags$p("Upload the RDS file obtained in the Preprocessing tab below in the input labelled
                         'RDS File Input'. Alternatively, explore the app by selecting 'Load Example Data'."),
                        tags$p("With Brushing set to Weighting, drag the mouse/cursor to select basepairs (columns)
                         on which to weight the ordering algorithm. Once the weighting is set, change Brushing to
                         refinement and highlight the molecules (rows) to refine the ordering."),
                        tags$p(
                            "Detailed
                         descriptions of the various options for seriation, weighting,
                         and refinement are in the ",
                            tags$a(
                                href = "http://bioconductor.org/packages/devel/bioc/vignettes/methylscaper/inst/doc/methylScaper.html",
                                "methylscaper vignette."
                            )
                        )
                    )
                ),
                fluidRow(sidebarLayout(
                    sidebarPanel(
                        actionButton("sm_demo_data", label = "Load Example Data", style = "background-color: rgb(209, 238, 238)"),
                        tags$br(),
                        tags$br(),
                        fileInput("sm_rds_file", label = "RDS File Input", accept = c(".rds", ".RDS")),
                        numericInput("sm_filter", label = "Filter reads - keep reads
                                     with % non-missing at least:", value = 0, min = 0, max = 100),
                        selectInput("sm_ser_method",
                            label = "Seriation Method:",
                            choices = c("PCA", "ARSA")
                        ),
                        selectInput("sm_refine_method",
                            label = "Refinement Method:",
                            choices = c("PCA", "HC_average")
                        ),
                        radioButtons("sm_brush_choice",
                            label = "Brushing for:",
                            choices = c("Refinement", "Weighting"), selected = "Weighting"
                        ),
                        actionButton("sm_force_reverse", label = "Reverse Current Ordering"),
                        verbatimTextOutput("sm_info"),
                        width = 3
                    ),
                    mainPanel(
                        fluidRow(
                            column(
                                width = 10,
                                plotOutput(
                                    outputId = "sm_seqPlot",
                                    brush = "sm_plot_brush", width = "100%"
                                )
                            ),
                            column(
                                width = 2, align = "left",
                                selectInput("sm_filetype", label = "File type", choices = c("PDF", "PNG", "SVG", "SVGZ")),
                                numericInput("sm_height", label = "Height (inches):", value = 7),
                                numericInput("sm_width", label = "Width (inches):", value = 7),
                                numericInput("sm_res", label = "Resolution for PNG (ppi):", value = 300),
                                shinyjs::disabled(downloadButton("sm_plot_down", label = "Download Heatmap")),
                                shinyjs::disabled(downloadButton("sm_log_down", label = "Download Ordering Log"))
                            )
                        )
                    )
                ))
            ),
            tabPanel(
                "Summary Statistics",
                fluidRow(
                    column(
                        10,
                        tags$p("Below are summary plots of the methylation data. The histogram on the left
                        calulates the proportion of methylated bases within each molecule. Choose whether to calculate this for
                        the endogenous methylation or the accessibility methylation. The plot in the middle calculates the percent of
                        molecules having methylation at each GCH (yellow) or HCG (red) site in the region. The plot on the right calculates
                        a population averaged methylation status over the entire region. The window size can be adjusted. This plot
                        is similar to the one in the middle but is easier to interpret when the region is large.")
                    )
                ),
                fluidRow(
                    column(10, radioButtons("sm_proportion_choice",
                        label = "Proportion of:",
                        choices = c("Accessibility Methylation", "Endogenous Methylation"), selected = "Accessibility Methylation"
                    )),
                    column(2, numericInput("sm_window_choice",
                        label = "Window size:",
                        value = 20
                    ))
                ),
                fluidRow(
                    splitLayout(
                        cellWidths = c("33%"),
                        plotOutput(outputId = "sm_proportion_color_histogram"),
                        plotOutput(outputId = "sm_percent_C"),
                        plotOutput(outputId = "sm_avg_c")
                    ),
                    splitLayout(
                        cellWidths = c("33%"),
                        shinyjs::disabled(downloadButton("sm_proportion_hist_download", label = "Download Histogram")),
                        shinyjs::disabled(downloadButton("sm_percentC_plot_download", label = "Download Plot")),
                        shinyjs::disabled(downloadButton("sm_avg_c_plot_download", label = "Download Plot"))
                    ),
                    splitLayout(
                        cellWidths = c("33%"),
                        shinyjs::disabled(downloadButton("sm_proportion_data_download", label = "Download Proportion Data")),
                        shinyjs::disabled(downloadButton("sm_percentC_data_download", label = "Download Percentage Data")),
                        shinyjs::disabled(downloadButton("sm_avg_c_data_download", label = "Download Averaged Percent Data"))
                    )
                )
            ),
            selected = "Visualization"
        )
    ),
    selected = "Single-molecule"
)

# Run the application
#' methylscaper
#'
#' Runs the methylscaper Shiny app.
#'
#' @return This starts up the shiny app interface for methylscaper.
#' @import shiny
#' @import shinyFiles
#' @import seriation
#' @importFrom shinyjs disabled useShinyjs enable showElement toggleElement
#' @importFrom seqinr read.fasta
#' @importFrom grDevices dev.off pdf png cairo_pdf
#' @importFrom utils write.csv capture.output data
#' @importFrom data.table fread
#' @export
#' @examples
#'
#' # methylscaper()
methylscaper <- function() {
    options(shiny.maxRequestSize = 10000 * 1024^5)

    shinyApp(ui = ui, server = server)
}

#' Generate Sequence Plot
#'
#' Generates an ordered sequence plot of methylation data.
#'
#' @param orderObject An object of class \code{orderObject} that contains
#'    the processed data and the ordering.
#' @param plotFast Logical, setting to FALSE will generate a higher
#'    quality plot. TRUE generates a lower resolution file, useful to improve
#'    speed while testing. For publication quality use plotFast=TRUE.
#' @param blankWidth Indicates the amount of space to leave between
#'     the two plots
#' @param Title The title of the plot.
#' @param drawLine Logical, indicates whether to draw a line above
#'    the CG/GC sites.
#' @param drawKey Logical, indicates whether to draw a key representing
#'    a 147bp nucleosome at the bottom of the plot.
#' @param shinySizer internal sizing parameter for plot layout in shiny app.
#'
#' @return Output is two side-by-side heatmaps with the endogenous
#'    methylation (HCG) on the left and the acciessibility methylation (GCH)
#'    on the right. The tick marks at the top indicate
#'    either HCG or GCH sites when drawLine=TRUE. If drawKey=TRUE then a black
#'    rectangle key is plot at the bottom of the heatmap that is 147 basepairs
#'    long. In the HCG plot, red patches represent methylation between two
#'    sites; black patches represent unmethylated bases between two
#'    unmethylated sites; and gray patches are base pairs which have one
#'    methylated site and one unmethylated site flanking. In the HCG plot,
#'    yellow patches represent accessibility between two sites; black patches
#'    represent occupied bases  between two occupied sites; and gray patches
#'    are base pairs which have one methylated site and one
#'    unmethylated site flanking.
#'
#' @importFrom graphics abline image par axis segments title
#' @export
#' @examples
#'
#' data(singlemolecule_example)
#'
#' orderObj <- initialOrder(singlemolecule_example, Method = "PCA")
#' plotSequence(orderObj)
plotSequence <- function(
        orderObject, plotFast = TRUE,
        blankWidth = NULL, Title = "",
        drawLine = TRUE, drawKey = TRUE, shinySizer = 0) {
    # Start with yellow at top as the default:
    toClust <- orderObject$toClust
    order1 <- orderObject$order1
    input_GCH <- toClust[, seq(1, (ncol(toClust) / 2))]
    input_HCG <- toClust[, seq((ncol(toClust) / 2 + 1), ncol(toClust))]

    myCols <- c(
        "darkgoldenrod2", "yellow", "gray62", "black",
        "gray80", "white", "gray80", "black", "gray62", "red", "darkred"
    )
    myBreaks <- c(-5, -4, -3, -2.5, -2, -1, 0, 1, 2, 2.5, 3, 4)

    if (nrow(toClust) == 1) {
        input_HCG <- t(as.matrix(input_HCG))
        input_GCH <- t(as.matrix(input_GCH))
    }

    input_HCG_fix <- input_HCG
    input_GCH_fix <- input_GCH

    # This spacing often looks best:
    if (is.null(blankWidth)) blankWidth <- round(.12 * ncol(toClust) / 2)

    blankCOLS <- matrix(rep(0, nrow(input_HCG) * blankWidth),
        nrow = nrow(input_HCG), ncol = blankWidth
    )
    toPlot_fix_og <- cbind(input_HCG_fix, blankCOLS, input_GCH_fix)

    sites <- which(apply(abs(toPlot_fix_og), 2, function(x) any(x %in% c(4, 1))))
    sites_scale <- sites / ncol(toPlot_fix_og) # relative to the 'plot'

    toPlot_fix <- toPlot_fix_og[rev(order1), ]

    if (nrow(toClust) == 1) {
        toPlot_fix <- t(as.matrix(toPlot_fix))
    }
    ## Add some rows in order to add a legend:
    if (drawKey == TRUE) {
        totalHeight <- pmax(ceiling(nrow(toPlot_fix) * 0.1), 3)
        blankROW <- matrix(rep(0, ncol(toPlot_fix) * totalHeight),
            nrow = totalHeight, ncol = ncol(toPlot_fix)
        )
        keyHeight <- pmax(ceiling(totalHeight * 0.5), 2)
        blankROW[seq(1, keyHeight), seq(1, 147)] <- 2 # 147 is nucleosome
        blankROW[seq(1, keyHeight), (seq(1, 147) + (ncol(input_HCG_fix) + ncol(blankCOLS)))] <- 2
        toPlot_fix <- rbind(blankROW, toPlot_fix)
    }
    # Plotting:
    if (shinySizer >= 750) TCK <- -.015 else TCK <- -.02
    if (shinySizer >= 750) TLINE <- .6 else TLINE <- .5
    if (shinySizer >= 750) topMAR <- 6 else topMAR <- 4

    par(xpd = FALSE, mar = c(2, 2, topMAR, 1), mgp = c(0, 0.5, 0))
    image(t(toPlot_fix),
        col = myCols, axes = FALSE, breaks = myBreaks,
        useRaster = plotFast, ylim = c(0, 1)
    )
    axis(3,
        at = sites_scale, labels = rep("", length(sites_scale)),
        tick = TRUE, line = TLINE, col = "white", cex = 1, lwd = 1,
        col.ticks = "black", tck = TCK
    )
    title(Title, line = 2, col.main = "royalblue4")

    # Where to put the axes:
    # convert these back to the site number so we can do refinement
    plot1 <- round(ncol(input_HCG_fix) / ncol(toPlot_fix), 2)
    plot2 <- round((ncol(input_HCG_fix) + blankWidth) / ncol(toPlot_fix), 2)

    if (shinySizer >= 750) lSHIFT <- 2.2 else lSHIFT <- 1.5
    # these shifts of 0.025 seem arbitrary but tend to center the title a bit better
    title("HCG", adj = plot1 / 2 - 0.025, line = lSHIFT)
    title("GCH", adj = plot2 + 0.025 + (1 - plot2) / 2, line = lSHIFT)

    toLabel <- rev(seq(1, length(order1), by = ceiling(length(order1) / 8)))
    if (!(length(order1) %in% toLabel)) toLabel <- c(length(order1), toLabel)
    y_axis_starting_point <- ifelse(drawKey, nrow(blankROW) / nrow(toPlot_fix), 0)
    axis(2, at = seq(y_axis_starting_point, 1,
        length.out = length(toLabel)
    ), labels = toLabel)

    toLabel <- round(c(
        seq(1, ncol(input_HCG_fix), length.out = 5),
        seq(1, ncol(input_GCH_fix), length.out = 5)
    ))
    axis(1, at = seq(0, plot1, length.out = 5), labels = toLabel[seq(1, 5)])
    axis(1, at = seq(plot2, 1, length.out = 5), labels = toLabel[seq(1, 5)])

    # Just drawing a straight DNA line:
    if (drawLine == TRUE) {
        par(xpd = NA)
        top1 <- 1.01
        segments(0, top1, plot1, top1, lwd = 1)
        segments(plot2, top1, 1, top1, lwd = 1)
    }
}

## ----eval=F-------------------------------------------------------------------
# if (!requireNamespace("BiocManager", quietly = TRUE)) {
#     install.packages("BiocManager")
# }
# 
# BiocManager::install("methylscaper")

## ----message = FALSE, warning=FALSE-------------------------------------------
library(methylscaper)

## ----eval=F-------------------------------------------------------------------
# methylscaper()

## ----eval=FALSE---------------------------------------------------------------
# filepath <- "~/Downloads/GSE109262_RAW/"
# singlecell_subset <- subsetSC(filepath, chromosome = 19, startPos = 8937041, endPos = 8997041)
# # To save for later, save as an rds file and change the folder location as desired:
# saveRDS(singlecell_subset, "~/Downloads/singlecell_subset.rds")

## ----eval=TRUE----------------------------------------------------------------
gse_subset_path <- list(
    c(
        "https://rbacher.rc.ufl.edu/methylscaper/data/GSE109262_SUBSET/GSM2936197_ESC_A08_CpG-met_processed.tsv.gz",
        "https://rbacher.rc.ufl.edu/methylscaper/data/GSE109262_SUBSET/GSM2936196_ESC_A07_CpG-met_processed.tsv.gz",
        "https://rbacher.rc.ufl.edu/methylscaper/data/GSE109262_SUBSET/GSM2936192_ESC_A03_CpG-met_processed.tsv.gz"
    ),
    c(
        "https://rbacher.rc.ufl.edu/methylscaper/data/GSE109262_SUBSET/GSM2936197_ESC_A08_GpC-acc_processed.tsv.gz",
        "https://rbacher.rc.ufl.edu/methylscaper/data/GSE109262_SUBSET/GSM2936196_ESC_A07_GpC-acc_processed.tsv.gz",
        "https://rbacher.rc.ufl.edu/methylscaper/data/GSE109262_SUBSET/GSM2936192_ESC_A03_GpC-acc_processed.tsv.gz"
    ),
    c("GSM2936197_ESC_A08_CpG-met_processed", "GSM2936196_ESC_A07_CpG-met_processed", "GSM2936192_ESC_A03_CpG-met_processed"),
    c("GSM2936197_ESC_A08_GpC-acc_processed", "GSM2936196_ESC_A07_GpC-acc_processed", "GSM2936192_ESC_A03_GpC-acc_processed")
)
# This formatting is a list of 4 objects: the met file urls, the acc file urls, the met file names, and the acc file names.
options(timeout = 1000)
singlecell_subset <- subsetSC(gse_subset_path, chromosome = 19, startPos = 8937041, endPos = 8997041)

# To save for later, save as an rds file and change the folder location as desired:
# saveRDS(singlecell_subset, "~/Downloads/singlecell_subset.rds")

## ----eval=TRUE, fig.width=7, fig.height=3-------------------------------------
data("mouse_bm")
gene.select <- subset(mouse_bm, mgi_symbol == "Eef1g")

startPos <- 8966841
endPos <- 8967541
prepSC.out <- prepSC(singlecell_subset, startPos = startPos, endPos = endPos)

orderObj <- initialOrder(prepSC.out)
plotSequence(orderObj, Title = "Eef1g gene", plotFast = TRUE, drawKey = FALSE)

## ----eval=TRUE, fig.align='left', fig.width=6, fig.height=5-------------------
# If you followed the preprocessing code above, then you can do:
# mydata <- readRDS("~/Downloads/singlecell_subset.rds")
# Otherwise, we have also included this subset in the package directly:
mydata <- system.file("extdata", "singlecell_subset.rds", package = "methylscaper")
mydata <- readRDS(mydata)
gene <- "Eef1g"
data("mouse_bm") # for human use human_bm
gene.select <- subset(mouse_bm, mgi_symbol == gene)
# We will further subset the region to a narrow region of the gene: from 8966841bp to 8967541bp
startPos <- 8966841
endPos <- 8967541

# This subsets the data to a specific region and prepares the data for visualization:
prepSC.out <- prepSC(mydata, startPos = startPos, endPos = endPos)

# Next the cells are ordered using the PCA approach and plot
orderObj <- initialOrder(prepSC.out)
plotSequence(orderObj, Title = "Eef1g gene", plotFast = TRUE)
# We plot the nucleosome size key by default, however this can be turned off via drawKey = FALSE:
# plotSequence(orderObj, Title = "Eef1g gene", plotFast=TRUE, drawKey = FALSE)

## ----eval=TRUE----------------------------------------------------------------
orderObj <- initialOrder(prepSC.out,
    weightStart = 47, weightEnd = 358, weightFeature = "acc"
)

## ----eval=TRUE, fig.width=7, fig.height=6-------------------------------------
plotSequence(orderObj, Title = "Eef1g gene", plotFast = TRUE)

## ----eval=TRUE, fig.width=7, fig.height=6-------------------------------------
orderObj$order1 <- refineFunction(orderObj, refineStart = 1, refineEnd = 20)
plotSequence(orderObj, Title = "Eef1g gene", plotFast = TRUE)

## ----eval=FALSE---------------------------------------------------------------
# png("~/save_my_plot.png", width = 4, height = 6, units = "in", res = 300)
# plotSequence(orderObj, Title = "Eef1g gene", plotFast = FASLE)
# dev.off()

## ----eval=FALSE---------------------------------------------------------------
# # if (!requireNamespace("biomaRt", quietly = TRUE)) {
# #     BiocManager::install("biomaRt")
# # }
# library(biomaRt)
# ensembl <- useMart("ensembl")
# # Demonstrating how to get the human annotations.
# ensembl <- useDataset("hsapiens_gene_ensembl", mart = ensembl)
# my_chr <- c(1:22, "M", "X", "Y") # You can choose to omit this or include additional chromosome
# # We only need the start, end, and symbol:
# human_bm <- getBM(
#     attributes = c("chromosome_name", "start_position", "end_position", "hgnc_symbol"),
#     filters = "chromosome_name",
#     values = my_chr,
#     mart = ensembl
# )
# 
# ## Now that we have the biomart object, we can extract start and ends for methylscaper:
# gene_select <- subset(human_bm, human_bm$hgnc_symbol == "GeneX")
# 
# # These can then be passed into the prepSC function:
# prepSC.out <- prepSC(mydata, startPos = gene_select$startPos, endPos = gene_select$endPos)
# 
# # To continue the analysis:
# # Next the cells are ordered using the PCA approach and then plot:
# orderObj <- initialOrder(prepSC.out)
# plotSequence(orderObj, Title = "Gene X", plotFast = TRUE)

## ----eval = TRUE--------------------------------------------------------------
# This provides the path to the raw datasets located in the methylscaper package
seq_file <- system.file("extdata", "seq_file.fasta", package = "methylscaper")
ref_file <- system.file("extdata", "reference.fa", package = "methylscaper")

# Next we read the data into R using the read.fasta function from the seqinr package:
fasta <- seqinr::read.fasta(seq_file)
ref <- seqinr::read.fasta(ref_file)[[1]]

# For the vignette we will only run a subset of the molecules
singlemolecule_example <- runAlign(fasta = fasta, ref = ref, fasta_subset = 1:150)

# Once complete, we can save the output as an RDS object
# saveRDS(singlemolecule_example, file="~/methylscaper_singlemolecule_preprocessed.rds")

## ----eval=TRUE, fig.width=7, fig.height=6-------------------------------------
# If skipping the preprocessing steps above, use our pre-aligned data:
# data(singlemolecule_example)
orderObj <- initialOrder(singlemolecule_example,
    Method = "PCA",
    weightStart = 308, weightEnd = 475, weightFeature = "red"
)
plotSequence(orderObj, Title = "Ordered by PCA", plotFast = TRUE)

## ----eval=TRUE, fig.align='left', fig.height=8, fig.width=8-------------------
par(mfrow = c(2, 2))
props <- methyl_proportion(orderObj, type = "met", makePlot = TRUE, main = "")
props <- methyl_proportion(orderObj, type = "acc", makePlot = TRUE, main = "")

pcnts <- methyl_percent_sites(orderObj, makePlot = TRUE)
avgs <- methyl_average_status(orderObj, makePlot = TRUE, window_length = 25)

## ----sessionInfo, results='markup'--------------------------------------------
sessionInfo()

#' Example preprocessed single-molecule experiment
#'
#' The RDS in ext data was made specifically with the command:
#' singlemolecule_example <- methylscaper::runAlign(fasta=reads_sm,
#' ref=ref_seq)
#' saveRDS(singlemolecule_example, file="methylscaper/inst/ext/singlemolecule_example.rds", compress = 'xz')
#' A version is also saved as RData used running examples in the man pages.
#' save(singlemolecule_example, file="methylscaper/data/singlemolecule_example.RData", compress = 'xz')
#' @docType data
#' @usage data(singlemolecule_example)
"singlemolecule_example"

#' Example reads from single-molecule experiment
#'
#' This dataset was loaded into R using seqinr::read.fasta
#' @docType data
#' @usage data(reads_sm)
"reads_sm"

#' Example reference sequence to align reads to from a
#' single-molecule experiment
#'
#' This dataset was loaded into R using seqinr::read.fasta
#' @docType data
#' @usage data(ref_seq)
"ref_seq"

#' Example preprocessed single-cell experiment subset
#'
#' This data is from GSE109262, and has been pre-processed by methylscaper
#' It contains a small subset of chromosome 19 region from 8947041bp - 8987041bp.
#' The RDS in ext data was made specifically with the two commands:
#' singlecell_subset <- subsetSC("~/Downloads/GSE109262_RAW/", chromosome="19",
#'    startPos = 8967041-20000, endPos = 8967041+20000, updateProgress = NULL)
#' saveRDS(singlecell_subset, file="methylscaper/inst/ext/singlecell_subset.rds", compress = 'xz')
#' A version is also saved as RData used running examples in the man pages.
#' save(singlecell_subset, file="methylscaper/data/singlecell_subset.RData", compress = 'xz')
#' @docType data
#' @usage data(singlecell_subset)
"singlecell_subset"

#' Human gene symbols and positions
#'
#' library(biomaRt) #v2.44.4
#' ensembl <- useMart("ensembl") # GRCh38
#' ensembl <- useDataset("hsapiens_gene_ensembl",mart=ensembl)
#' my_chr <- c(1:22, 'M', 'X', 'Y')
#' human_bm <- getBM(attributes=c('chromosome_name', 'start_position', 'end_position', 'hgnc_symbol'),
#'             filters = 'chromosome_name',
#'             values = my_chr,
#'             mart=ensembl)
#'
#' @docType data
#' @usage data(human_bm)
"human_bm"

#' Mouse gene symbols and positions
#'
#' library(biomaRt) #v2.44.4
#' ensembl <- useMart("ensembl") # GRCm39
#' ensembl <- useDataset("mmusculus_gene_ensembl",mart=ensembl)
#' my_chr <- c(1:19, 'M', 'X', 'Y')
#' mouse_bm <- getBM(attributes=c('chromosome_name', 'start_position', 'end_position', 'mgi_symbol'),
#'             filters = 'chromosome_name',
#'             values = my_chr,
#'             mart=ensembl)
#'
#' @docType data
#' @usage data(mouse_bm)
"mouse_bm"

#' Align the single-molecule data
#'
#' Runs the preprocessing methods for single-molecule data.
#'
#' @param ref A reference sequence to align the reads to.
#' @param fasta A list of reads/sequences from a single-molecule experiment (e.g. MAPit)
#' @param fasta_subset (optional) A vector of indices indicating which
#'      sequences to process if a subset should be used. Leave this blank if
#'      all sequences should be processed.
#' @param multicoreParam (optional) A MulticoreParam object, used to align
#'      sequences in parallel.
#' @param updateProgress (optional) Used to add a progress bar to the Shiny app.
#'      Should not be used otherwise.
#' @param log_file (optional) String indicating where to save a log of the
#'      alignment process. If left NULL, no log is saved. We highly recommend
#'      saving a log file.
#' @param score_cutoff (optional) Used mostly for testing purposes.
#' @return The output is a list containing the the matrices 'gch' and 'hcg.
#'       Each is a dataframe with reads/cells on the rows and each column
#'      is a base-pair. The matrix represents the methylation state for cell
#'      across all base pairs. The coding is as follows:
#'          -2: unmethylated GCH or HCG site
#'          -1: base pairs between two unmethylated GCH or HCG sites
#'          0: base pairs between mismatching methylation states of
#'              two GCH or HCG sites
#'          1: base pairs between two methylated GCH or HCG sites
#'          2: methylated GCH or HCG site
#' @importFrom Biostrings DNAString DNA_ALPHABET reverseComplement
#' @importFrom pwalign pairwiseAlignment score alignedPattern alignedSubject mismatchTable
#' @importFrom seqinr c2s s2c read.fasta
#' @importFrom BiocParallel bplapply
#' @export
#' @examples
#'
#' data(reads_sm)
#' data(ref_seq)
#' example_alignedseq <- runAlign(fasta = reads_sm, ref = ref_seq[[1]], fasta_subset = 1:150)
runAlign <- function(ref, fasta, fasta_subset = seq(1, length(fasta)),
    multicoreParam = NULL,
    updateProgress = NULL,
    log_file = NULL, score_cutoff = NULL) {
    fasta <- fasta[fasta_subset]
    ref_string <- DNAString(toupper(c2s(ref)))

    log_vector <- c("Beginning preprocessing")

    if (is.function(updateProgress)) {
        updateProgress(message = "Aligning sequences", value = 0.1)
    }
    alignment_out <- alignSequences(
        fasta, ref_string, log_vector,
        multicoreParam, updateProgress, score_cutoff
    )

    alignedseq <- alignment_out$alignedseq
    log_vector <- alignment_out$log_vector

    if (is.function(updateProgress)) {
        updateProgress(message = "Identifying sites", value = 0.75)
    }
    # We want to avoid GCG sites:
    GCsites <- gregexpr("GC", c2s(ref_string), fixed = TRUE)[[1]] + 1
    CGsites <- gregexpr("CG", c2s(ref_string), fixed = TRUE)[[1]]

    cg_site_use <- s2c(paste(ref_string))[CGsites - 1]
    gc_site_use <- s2c(paste(ref_string))[GCsites + 1]

    log_vector <- c(log_vector, paste(
        "Throwing out",
        length(which(gc_site_use == "G")) + length(which(cg_site_use == "G")), "GCG sites"
    ))

    CGsites <- CGsites[which(cg_site_use != "G")]
    GCsites <- GCsites[which(gc_site_use != "G")]

    if (is.function(updateProgress)) {
        updateProgress(message = "Mapping sites", value = 0.8)
    }
    if (alignment_out$siteOrient == "rev") {
        GCsitesForMapping <- GCsites - 1
        CGsitesForMapping <- CGsites + 1
    } else {
        GCsitesForMapping <- GCsites
        CGsitesForMapping <- CGsites
    }

    if (is.null(multicoreParam)) {
        gcmap <- lapply(alignedseq, mapseq,
            sites = GCsitesForMapping,
            siteOrient = alignment_out$siteOrient
        )
        cgmap <- lapply(alignedseq, mapseq,
            sites = CGsitesForMapping,
            siteOrient = alignment_out$siteOrient
        )
    } else {
        gcmap <- bplapply(alignedseq, mapseq,
            sites = GCsitesForMapping,
            siteOrient = alignment_out$siteOrient,
            BPPARAM = multicoreParam
        )
        cgmap <- bplapply(alignedseq, mapseq,
            sites = CGsitesForMapping,
            siteOrient = alignment_out$siteOrient,
            BPPARAM = multicoreParam
        )
    }

    if (is.function(updateProgress)) {
        updateProgress(message = "Preparing matrices", value = 0.95)
    }

    saveCG <- data.matrix(do.call(rbind, lapply(cgmap, function(x) (x))))
    saveCG <- cbind(rownames(saveCG), saveCG)

    saveGC <- data.matrix(do.call(rbind, lapply(gcmap, function(x) (x))))
    saveGC <- cbind(rownames(saveGC), saveGC)
    if (is.function(updateProgress)) updateProgress(message = "Done", value = 1)

    return(list(hcg = saveCG, gch = saveGC, logs = log_vector))
}


# this handles the alignment of ALL the sequences, and returns the
# alignedseq object used in the runAlign function
# this needs the log_vector, multicoreParam, and updateProgress
# so that we can continue keeping track of these things
alignSequences <- function(fasta, ref_string, log_vector,
    multicoreParam = NULL, updateProgress = NULL, score_cutoff) {
    ## this creates the substitution matrix for use in alignment
    penalty_mat <- matrix(
        0, length(DNA_ALPHABET[seq(1, 4)]),
        length(DNA_ALPHABET[seq(1, 4)])
    )
    penalty_mat[seq(1, 4), seq(1, 4)] <- c(1, 0, 1, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 1, 0, 1)
    penalty_mat[penalty_mat == 0] <- -5
    penalty_mat <- cbind(penalty_mat, c(0, 0, 0, 0))
    penalty_mat <- rbind(penalty_mat, c(0, 0, 0, 0, 1))
    rownames(penalty_mat) <- colnames(penalty_mat) <- c(DNA_ALPHABET[seq(1, 4)], "N")

    if (is.null(multicoreParam)) {
        seqalign_out <- lapply(
            seq(1, length(fasta)),
            function(i) {
                if (is.function(updateProgress)) {
                    updateProgress(
                        message = "Aligning sequences",
                        detail = paste(i, "/", length(fasta)),
                        value = (0.1 + 0.65 / length(fasta) * i)
                    )
                }
                seqalign(fasta[[i]], ref_string, substitutionMatrix = penalty_mat)
            }
        )
    } else {
        seqalign_out <- bplapply(seq(1, length(fasta)),
            function(i) {
                seqalign(fasta[[i]], ref_string,
                    substitutionMatrix = penalty_mat
                )
            },
            BPPARAM = multicoreParam
        )
    }
    useseqs <- lapply(seqalign_out, function(i) i$u)
    scores <- vapply(seqalign_out, function(i) i$score, numeric(1))
    maxAligns <- vapply(seqalign_out, function(i) i$maxAlign, numeric(1))


    if (is.null(score_cutoff)) {
        score_cutoff_idx <- which.max(diff(sort(scores))) + 1
        score_cutoff <- sort(scores)[score_cutoff_idx]
    }

    good_alignment_idxs <- which(scores > score_cutoff)

    if (length(good_alignment_idxs) == 0) {
        stop("No good alignments were found. See methylscaper FAQ for more details.")
    }

    alignedseq <- lapply(good_alignment_idxs, function(i) {
        SEQ1 <- s2c(paste(alignedPattern(useseqs[[i]])))
        SEQ2 <- s2c(paste(alignedSubject(useseqs[[i]])))

        toreplace <- SEQ1[which(SEQ2 == "-")]
        toreplace[toreplace != "C"] <- "."
        toreplace[toreplace == "C"] <- "."

        SEQ2[which(SEQ2 == "-")] <- toreplace
        SEQ2 <- SEQ2[which(SEQ1 != "-")]
        # if (maxAligns[i] == 1) SEQ2 <- s2c(paste(reverseComplement(DNAString(c2s(SEQ2)))))
        return(SEQ2)
    })
    log_vector <- c(log_vector, paste(
        "Throwing out",
        length(useseqs) - length(good_alignment_idxs), "alignments"
    ))

    names(alignedseq) <- names(fasta)[good_alignment_idxs]

    getOrientation <- lapply(good_alignment_idxs, function(i) {
        mismt <- mismatchTable(useseqs[[i]])
        mismt <- c(mismt$PatternSubstring, mismt$SubjectSubstring)
        mismm_nt <- names(sort(table(mismt), decreasing = TRUE)[c(1, 2)])
        return(mismm_nt)
    })
    getOrientation <- table(unlist(getOrientation))
    if (!is.na(getOrientation["A"]) & !is.na(getOrientation["T"]) & getOrientation["A"] > getOrientation["T"]) {
        siteOrient <- "rev"
    } else if (is.na(getOrientation["C"]) & is.na(getOrientation["T"])) {
        siteOrient <- "rev"
    } else {
        siteOrient <- "stnd"
    }

    return(list(alignedseq = alignedseq, log_vector = log_vector, siteOrient = siteOrient))
}

# aligns a single read to the reference, returns the useseq string.
# Alignment is finished in the alignSequences fn
seqalign <- function(read, ref_string, substitutionMatrix) {
    fasta_string <- DNAString(toupper(c2s(read)))

    align_bb <- pairwiseAlignment(reverseComplement(ref_string),
        reverseComplement(fasta_string),
        type = "global-local", gapOpening = 8,
        substitutionMatrix = substitutionMatrix
    )
    align_ab <- pairwiseAlignment(ref_string, reverseComplement(fasta_string),
        type = "global-local", gapOpening = 8,
        substitutionMatrix = substitutionMatrix
    )
    align_aa <- pairwiseAlignment(ref_string, fasta_string,
        type = "global-local",
        gapOpening = 8,
        substitutionMatrix = substitutionMatrix
    )
    align_ba <- pairwiseAlignment(reverseComplement(ref_string), fasta_string,
        type = "global-local",
        gapOpening = 8,
        substitutionMatrix = substitutionMatrix
    )

    maxAlign <- which.max(c(score(align_aa), score(align_ab), score(align_bb), score(align_ba)))
    allseq <- list(align_aa, align_ab, align_bb, align_ba)
    useseq <- allseq[[maxAlign]]

    return(list(u = useseq, score = score(useseq), maxAlign = maxAlign))
}

mapseq <- function(i, sites, siteOrient) {
    editseq <- i

    if (siteOrient == "rev") {
        editseq[sites][editseq[sites] == "."] <- "A"
        editseq[sites][editseq[sites] == "A"] <- "-2"
        editseq[sites][editseq[sites] == "G"] <- "2"
        editseq[sites][editseq[sites] == "C"] <- "."
        editseq[sites][editseq[sites] == "T"] <- "."
    } else {
        editseq[sites][editseq[sites] == "."] <- "T"
        editseq[sites][editseq[sites] == "T"] <- "-2"
        editseq[sites][editseq[sites] == "C"] <- "2"
        editseq[sites][editseq[sites] == "G"] <- "."
        editseq[sites][editseq[sites] == "A"] <- "."
    }
    editseq[sites][editseq[sites] == "N"] <- "."
    # we need to make sure that the N sites stay marked with a "."
    missing_bp <- which(editseq == ".")

    sites_temp <- c(0, sites, length(editseq) + 1)
    for (j in seq(1, (length(sites_temp) - 1))) {
        tofill <- seq(sites_temp[j] + 1, (sites_temp[j + 1] - 1))
        s1 <- editseq[pmax(1, sites_temp[j])]
        s2 <- editseq[pmin(length(i), sites_temp[j + 1])]
        is_first <- (pmax(1, sites_temp[j]) == 1)

        if (s1 == "2" & s2 == "2") {
            fillvec <- 1
        } else if (s1 == "2" & s2 == "-2") {
            fillvec <- 0
        } else if (s1 == "-2" & s2 == "2") {
            fillvec <- 0
        } else if (s1 == "-2" & s2 == "-2") {
            fillvec <- -1
        } else if (s1 == "." & s2 == ".") {
            fillvec <- "."
        } else if (is_first & s2 == ".") {
            fillvec <- "."
        } else {
            fillvec <- 0
        }
        fillvec <- rep(fillvec, length(tofill))
        editseq[tofill] <- fillvec
        editseq[intersect(tofill, missing_bp)] <- "."
    }

    substring_table <- get_contig_substrings(editseq)
    long_missing <- which(substring_table$char == "." & substring_table$count > 3)
    short_non_missing <- which(substring_table$char == "-" &
        substring_table$count <= 20)
    short_non_missing_sr <- short_non_missing[(short_non_missing + 1)
    %in% long_missing | (short_non_missing - 1) %in% long_missing]
    counts <- as.numeric(substring_table$count)
    # missing artifacts
    for (idx in short_non_missing_sr) {
        if (idx == 1) {
            editseq[seq(1, counts[idx])] <- "."
        } else {
            first <- sum(counts[seq(1, (idx - 1))]) + 1
            last <- first + counts[idx] - 1
            editseq[seq(first, last)] <- "."
        }
    }
    return(editseq)
}


## we want to be able to get all contiguous substrings of a certain string...
# in particular one of the editseq strings used above
## i want to return a table
get_contig_substrings <- function(s) {
    ## we want some sort of table to keep track of the substrings
    substring_table <- data.frame(char = "a", count = 0)

    s <- ifelse(s == ".", ".", "-") ## use "-" to denote the non-missing ones,
    # so we only keep track of missing and non missing
    i <- 1
    while (i <= length(s)) {
        j <- i
        while (s[j] == s[i] & j <= length(s)) j <- j + 1
        substring_table <- rbind(substring_table, c(s[i], j - i))
        i <- j
    }
    substring_table <- data.frame(
        char = substring_table$char[-1],
        count = as.numeric(substring_table$count[-1])
    )
    return(substring_table)
}

#' Calculates the percentage of methylated cells/molecules per site
#'
#' @param orderObject An object of class \code{orderObject}
#' @param makePlot Logical, indicates whether to generate the percentage plot
#' @param ... Additional parameters used by the \code{plot} function.
#' @return The percent of molecules or cells methylated (endogenous (yellow)
#'      or accessible) at each site. Output is a list with names "red"
#'      and "yellow". Red represents the endogenous methylation and
#'      yellow represents the accessibility. Within each list object is a
#'      vector of the percent of cells/molecules methylated. The location
#'      of the site is also represent in the form CXX, where XX is the
#'      position of the site within the defined region.
#' @importFrom graphics hist lines plot points
#' @export
#' @examples
#'
#' data(singlemolecule_example)
#'
#' orderObj <- initialOrder(singlemolecule_example, Method = "PCA")
#' methyl_percent_sites(orderObj, makePlot = TRUE)
methyl_percent_sites <- function(orderObject, makePlot = TRUE, ...) {
    dat <- orderObject$toClust

    red_sites <- c(which(dat == 4, arr.ind = TRUE)[, 2], which(dat == 1, arr.ind = TRUE)[, 2])
    red_sites <- sort(unique(red_sites))
    yellow_sites <- c(which(dat == -4, arr.ind = TRUE)[, 2], which(dat == -1, arr.ind = TRUE)[, 2])
    yellow_sites <- sort(unique(yellow_sites))

    c_red <- vapply(red_sites, function(i) {
        sum(dat[, i] == 4) / nrow(dat)
    }, numeric(1))
    c_yellow <- vapply(yellow_sites, function(i) {
        sum(dat[, i] == -4) / nrow(dat)
    }, numeric(1))
    if (makePlot) {
        plot(
            x = red_sites - ncol(dat) / 2, y = c_red,
            col = "brown1", pch = 19, ylim = c(0, 1),
            xlab = "Position in the genomic region", ylab = "% methylated",
            bty = "n", cex.lab = 1.3, ...
        )
        lines(x = red_sites - ncol(dat) / 2, y = c_red, col = "brown1")
        points(x = yellow_sites, y = c_yellow, col = "gold2", pch = 19)
        lines(x = yellow_sites, y = c_yellow, col = "gold2")
        legend("topright", c("Endogenous", "Accessibility"),
            pch = 16,
            col = c("brown1", "gold2"), bty = "n", title = "Methylation Type"
        )
        n_sites <- length(union(red_sites, yellow_sites))
        labs <- union(red_sites, yellow_sites)[seq(1, n_sites, by = n_sites / 12)]
    }
    final <- list(c_red, c_yellow)
    names(final) <- c("meth", "acc")
    return(final)
}

#' Calculate the proportion of methylated bases for each cell/molecule
#'
#' @param orderObject An object of class \code{orderObject}
#' @param type Indicates which data set to compute proportions for.
#'      This should be 'met' or 'hcg' or 'red' for endogenous methylation; 'acc' or
#'      'gch' or 'yellow' for accessibility.
#' @param makePlot Indicates whether to plot a histogram of the proportions
#'  across all cells/molcules.
#' @param ... Additional parameters used by the \code{hist} function.
#'
#' @return The proportion of methylated (endogenous (yellow)
#'      or accessible) bases for each cell/molecule. Output is vector
#'      with length the numbner of cells/molecules and contains a proportion.
#' @importFrom graphics hist
#' @export
#' @examples
#'
#' data(singlemolecule_example)
#'
#' orderObj <- initialOrder(singlemolecule_example, Method = "PCA")
#' methyl_proportion(orderObj, makePlot = TRUE)
methyl_proportion <- function(orderObject, type = "yellow",
    makePlot = TRUE, ...) {
    type <- tolower(type)
    if (type == "gch") type <- "yellow"
    if (type == "accessibility methylation") type <- "yellow"
    if (type == "acc") type <- "yellow"
    color_indicator <- ifelse(type == "yellow", -1, 1)
    Proportion <- apply(orderObject$toClust, 1, function(x) {
        sum(x == color_indicator * 3 | x == color_indicator * 4) / (length(x) / 2)
    })
    if (makePlot) {
        opar <- par(lwd = 4)
        H <- hist(Proportion, plot = FALSE, breaks = 15)
        plot(H,
            xlim = c(0, 1), border = ifelse(type == "yellow", "gold2", "brown1"),
            col = "gray75", cex.lab = 1.3,
            lwd = 2, ...
        )
        par(opar)
    }
    Proportion <- data.frame(methylationProportion = Proportion)
    return(Proportion)
}

#' Calculate the average methylation/accessibility status across all cells/molecules.
#'
#' @param orderObject An object of class \code{orderObject}
#' @param window_length Length of the window to be used to compute a
#'          moving average. Default is 20.
#' @param makePlot Logical, indicates whether to generate a line plot of
#'          average status.
#' @param ... Addition parameters used by the \code{plot} function.
#'
#' @return The proportion of methylated bases for each cell/molecule
#'      within a defined moving window. Output is a list with elements
#'      "meth_avg" and "acc_avg", indicating endogenous
#'      or accessible methylation respectively.
#' @importFrom stats filter
#' @importFrom graphics legend
#' @export
#' @examples
#'
#' data(singlemolecule_example)
#'
#' orderObj <- initialOrder(singlemolecule_example, Method = "PCA")
#' methyl_average_status(orderObj, makePlot = TRUE)
#'
methyl_average_status <- function(orderObject, window_length = 20,
    makePlot = TRUE, ...) {
    colLength <- ncol(orderObject$toClust)
    gch_num <- orderObject$toClust[, seq(1, (colLength / 2))]
    hcg_num <- orderObject$toClust[, seq((colLength / 2 + 1), colLength)]

    acc_sum <- colSums(gch_num <= -3)
    meth_sum <- colSums(hcg_num >= 3)
    acc_denom <- colSums(gch_num != 0)
    meth_denom <- colSums(hcg_num != 0)
    acc_avg <- acc_sum / acc_denom
    meth_avg <- meth_sum / meth_denom

    width <- window_length
    moving_acc_avg <- filter(x = acc_avg, filter = rep(1, width)) / width
    moving_meth_avg <- filter(x = meth_avg, filter = rep(1, width)) / width

    if (makePlot) {
        plot(
            x = seq(1, length(moving_acc_avg)), y = moving_acc_avg,
            type = "l", col = "gold2", lwd = 2, bty = "n",
            xlab = "Position in the genomic region",
            ylab = "Averaged % methylation status",
            cex.lab = 1.3, ylim = c(0, 1), ...
        )
        lines(moving_meth_avg, col = "brown1", lwd = 2)
        legend("topright", c("Endogenous", "Accessibility"),
            lwd = 2,
            col = c("brown1", "gold2"), bty = "n", title = "Methylation Type"
        )
    }
    return(list(meth_avg = moving_meth_avg, acc_avg = moving_acc_avg))
}

#' Refinement
#'
#' Reorders a subset of the methylation data.
#'
#' @param orderObject An object of class \code{orderObject}, generated
#'  with the \code{initialOrder} function.
#' @param refineStart The index of the first sample (row) used
#'  in the refinement.
#' @param refineEnd The index of the last sample (row) used in the refinement.
#' @param Method The seriation method used to perform the refinement.
#'
#' @return The refinement reorders the cells/molecules (rows) between the indicated
#' start and end positions. The function returns the new complete ordering
#' with the refinement applied.
#' @importFrom seriation seriate get_order
#' @export
#'
#' @examples
#'
#' data(singlemolecule_example)
#'
#' orderObj <- initialOrder(singlemolecule_example, Method = "PCA")
#' # reordering the first 50 cells/molecules (rows)
#' orderObj$order1 <- refineFunction(orderObj, 1, 50)
refineFunction <- function(orderObject, refineStart, refineEnd,
    Method = "PCA") {
    toClust <- orderObject$toClust
    order1 <- orderObject$order1

    if (refineEnd > max(order1) | refineStart > max(order1)) {
        message(paste0("Refine parameters are out of bounds. The maximum has been set to ", refineEnd))
        if (refineEnd > max(order1)) refineEnd <- max(order1)
        if (refineStart > max(order1)) refineStart <- max(order1)
    }
    if (refineEnd < min(order1) | refineStart < min(order1)) {
        message(paste0("Refine parameters are out of bounds. The maximum has been set to ", refineEnd))
        if (refineEnd < min(order1)) refineEnd <- min(order1)
        if (refineStart < min(order1)) refineStart <- min(order1)
    }



    toRefine_order <- order1[refineStart:refineEnd]


    toRefine_clust <- toClust[toRefine_order, ]

    if (Method == "PCA") {
        col_centered <- apply(toRefine_clust, 2, function(x) x - mean(x))
        try1 <- svd(col_centered, nu = 1, nv = 0)
        order_new <- order(try1$u[, 1])
    } else { # Methods available for refining are: ARSA, HC_complete,
        ## HC_average, HC_ward.
        if (is.null(orderObject$distMat)) {
            distMat <- dist(toRefine_clust,
                method = "euclidean"
            )
        } else {
            distMat <- as.dist(as.matrix(orderObject$distMat)[toRefine_order, toRefine_order])
        }
        order_new <- seriate(distMat, method = Method, verbose = FALSE)
        order_new <- get_order(order_new)
    }


    # New order:
    order_new <- order1[seq(refineStart, refineEnd)][order_new]
    order_final <- order1
    order_final[refineStart:refineEnd] <- order_new

    return(order_final)
}

#' Force reversal of a subset of the ordering
#'
#' This reverses a subset of the ordering, as determined by the user.
#' By default, the entire ordering is reversed.
#'
#' @param orderObject An object of class \code{orderObject},
#'  generated with the \code{initialOrder} function.
#' @param reverseStart The first index to be included in the reversal.
#' @param reverseEnd The last index to be included in the reversal.
#'
#' @return The new complete ordering, with the reversal applied.
#' @export
#' @examples
#'
#' data(singlemolecule_example)
#'
#' orderObj <- initialOrder(singlemolecule_example, Method = "PCA")
#' # reorder first 50 cells/molecules (rows)
#' orderObj$order1 <- refineFunction(orderObj, 1, 50)
#' orderObj$order1 <- forceReverse(orderObj, 1, 50)
forceReverse <- function(orderObject, reverseStart = 1,
    reverseEnd = length(orderObject$order1)) {
    order1 <- orderObject$order1
    order1[reverseStart:reverseEnd] <- rev(order1[reverseStart:reverseEnd])
    return(order1)
}

buildOrderObjectShiny <- function(dataIn, method,
    coordinatesObject, updateProgress) {
    if (coordinatesObject$weight_start == 0 | coordinatesObject$weight_stop == 0) {
        orderObject <- initialOrder(dataIn, Method = method)
    } else {
        orderObject <- initialOrder(dataIn,
            Method = method,
            weightStart = coordinatesObject$weight_start,
            weightEnd = coordinatesObject$weight_stop,
            weightFeature = coordinatesObject$weight_color,
            updateProgress = updateProgress
        )
    }
    return(orderObject)
}

refineOrderShiny <- function(orderObject, refine_method, coordinatesObject) {
    refineFunction(orderObject, coordinatesObject$refine_start,
        coordinatesObject$refine_stop,
        Method = refine_method
    )
}

drawPlot <- function(orderObject, coordinatesObject, blankWidth = NULL, drawLines = TRUE, ...) {
    plotSequence(orderObject, ...)

    if (is.null(blankWidth)) blankWidth <- ceiling(.12 * ncol(orderObject$toClust) / 2)

    # draw the horizontal lines
    if (coordinatesObject$refine_start != 0 & coordinatesObject$refine_stop != 0) {
        n <- nrow(orderObject$toClust) # convert back to raw coordinates
        ymin <- (((n:1)[coordinatesObject$refine_start] / n * (n - 12)) + 12) / n
        ymax <- (((n:1)[coordinatesObject$refine_stop] / n * (n - 12)) + 12) / n
        if (drawLines) {
            abline(b = 0, a = ymax, col = "blue", lwd = 2.5)
            abline(b = 0, a = ymin, col = "blue", lwd = 2.5)
        }
    }
    # draw the vertical lines
    if (coordinatesObject$weight_start != 0 & coordinatesObject$weight_stop != 0) {
        firstm <- (ncol(orderObject$toClust) + blankWidth)
        xmin <- coordinatesObject$weight_start / firstm
        xmax <- coordinatesObject$weight_stop / firstm
        if (coordinatesObject$weight_color == "yellow") {
            secondm <- (blankWidth + ncol(orderObject$toClust) / 2) / firstm
            xmin <- xmin + secondm
            xmax <- xmax + secondm
        }
        if (drawLines) {
            abline(v = xmin, col = "green", lwd = 2.5)
            abline(v = xmax, col = "green", lwd = 2.5)
        }
    }
}

handleBrushCoordinates <- function(plot_brush, n, m, blankWidth = NULL) {
    if (is.null(blankWidth)) blankWidth <- ceiling(.12 * m)

    weight_color <- "red"
    first_row_raw <- round(plot_brush$ymin * n) - 12
    last_row_raw <- round(plot_brush$ymax * n) - 12
    first_row <- round((first_row_raw / (n - 12)) * n)
    last_row <- round((last_row_raw / (n - 12)) * n)

    if (first_row <= 2) first_row <- 1
    if (last_row >= n - 1) last_row <- n

    if (first_row >= n - 1 | last_row <= 2) {
        first_row <- 0
        last_row <- 0
    }

    first_col <- round(plot_brush$xmin, 4)
    last_col <- round(plot_brush$xmax, 4)
    firstm <- (m) / (m * 2 + blankWidth)
    secondm <- (blankWidth + m) / (m * 2 + blankWidth)
    if (first_col <= firstm) { # red weighting
        if (last_col >= firstm) last_col <- firstm # force the last column to be in red
        first_col <- first_col / firstm
        first_col <- round(first_col * m)
        last_col <- last_col / firstm
        last_col <- round(last_col * m)
    } else if (first_col >= secondm) { # yellow weighting
        weight_color <- "yellow"
        first_col <- first_col - secondm
        last_col <- last_col - secondm

        first_col <- first_col / firstm
        first_col <- round(first_col * m)
        last_col <- last_col / firstm
        last_col <- round(last_col * m)
    } else { # in the middle, just set them to 0
        first_col <- 0
        last_col <- 0
    }

    if (first_col <= 2) first_col <- 1
    if (last_col >= (m - 2)) last_col <- m

    return(list(
        first_row = ifelse(first_row == 0, 0, seq(n, 1)[first_row]),
        last_row = ifelse(last_row == 0, 0, seq(n, 1)[last_row]),
        first_col = first_col, last_col = last_col,
        weight_color = weight_color
    ))
}

#' Ordering the molecules/reads
#'
#' This function performs the weighted seriation procedure
#' described in the methylscaper manuscript if the method is set to "PCA".
#' The data may also be ordered using a given seriation method from the
#' seriation R package. The weighting is done between a designated start and end
#' base pair chosen by the user, and the weight can be done on the
#' endogenous methylation or the accessibility.
#'
#' @param dataIn A list object containing two elements labelled gch and hcg (already pre-processed.)
#' @param Method Indicates the seriation method to use. The default option
#'  is "PCA", which orders the data using a weighted first principal component approach. Any
#'  seriation method provided in the \code{seriation} package is also valid input.
#' @param weightStart Index of the first column used in the weighted seriation.
#' @param weightEnd Index of the last column used in the weighted seriation.
#' @param weightFeature Indicates whether to weight the GCH or HCG data.
#' Valid input to weight the GCH is 'gch', 'acc', or 'yellow'. To weight the HCG,
#' valid input for this option is 'hcg', 'met', or 'red'.
#' @param updateProgress A function to handle the progress bar for the
#' Shiny app. Should not be used when using the function independently.
#'
#' @return An object of class \code{orderObject}, which contains the generated
#'  ordering ($order1) and a clean data matrix ($toClust)
#'  to be passed into the plotting function plotSequence().
#' @importFrom seriation seriate get_order
#' @importFrom stats as.dist dist
#' @importFrom Rfast Dist
#' @importFrom data.table data.table
#' @export
#' @examples
#'
#' data(singlemolecule_example)
#'
#' orderObj <- initialOrder(singlemolecule_example)
initialOrder <- function(
        dataIn, Method = "PCA", weightStart = NULL,
        weightEnd = NULL, weightFeature = "red",
        updateProgress = NULL) {
    input_GCH <- dataIn$gch
    input_HCG <- dataIn$hcg

    ## File checks:

    if (is.null(updateProgress) & !is.list(dataIn)) {
        stop("No valid sites in designated range. Choose another gene or adjust
                start and end positions with a larger range")
    }
    if (nrow(input_HCG) != nrow(input_GCH)) {
        stop("Input files have different numbers of rows.")
    }

    if (all(rownames(input_GCH) == input_GCH[, 1])) input_GCH <- input_GCH[, -1]
    if (all(rownames(input_HCG) == input_HCG[, 1])) input_HCG <- input_HCG[, -1]

    input_GCH <- data.table::data.table(input_GCH)
    input_HCG <- data.table::data.table(input_HCG)

    if (is.function(updateProgress)) {
        updateProgress(message = "Recoding input data", value = 0.1)
    }

    recoded <- recode(input_GCH, input_HCG)
    input_GCH <- recoded$input_GCH
    input_HCG <- recoded$input_HCG

    weightFeature <- tolower(weightFeature)


    if (nrow(dataIn$gch) == 1) {
        toClust <- t(as.matrix(c(input_GCH, input_HCG)))
        order1 <- 1
        orderObject <- list(toClust = toClust, order1 = order1)
    } else {
        toClust <- cbind(input_GCH, input_HCG)
        weighted <- FALSE

        # (Optional) Weighting: Adds a variable indicating the number
        # of red or yellow patches at specific DNA location
        if (!is.null(weightStart) & !is.null(weightEnd)) {
            if (is.function(updateProgress)) {
                updateProgress(message = "Weighting selected columns", value = 0.2)
            }

            weighted <- TRUE

            if (weightStart < 1) weightStart <- 1
            if (weightEnd > ncol(input_HCG)) {
                print("Setting weightEnd to maximum columns")
                weightEnd <- ncol(input_HCG)
            }
            if (weightFeature == "red" | weightFeature == "hcg" | weightFeature == "met") {
                FEATURE <- 3
                weightVector <- apply(
                    input_HCG[, seq(weightStart, weightEnd)],
                    1, function(x) sum(x == FEATURE)
                )
            } else if (weightFeature == "yellow" | weightFeature == "gch" | weightFeature == "acc") {
                FEATURE <- -3
                weightVector <- apply(
                    input_GCH[, seq(weightStart, weightEnd)],
                    1, function(x) sum(x == FEATURE)
                )
            } else {
                print("weightFeature value is not valid, see ?weightFeature for valid values")
            }
            weightVector[weightVector == 0] <- 1 # we dont want to have 0 weights
        }

        if (is.function(updateProgress)) {
            updateProgress(message = paste("Ordering with", Method), value = 0.35)
        }
        ## PCA should be the default method:
        if (Method == "PCA") {
            if (weighted) {
                w <- weightVector / sum(weightVector)
                w_sqrt <- sqrt(w)
                toClust_weighted <- diag(w_sqrt) %*% toClust

                col_centered <- apply(toClust_weighted, 2, function(x) x - mean(x))
                try1 <- svd(col_centered, nu = 1, nv = 0)
                order1 <- order(try1$u[, 1])
            } else {
                col_centered <- apply(toClust, 2, function(x) x - mean(x))
                try1 <- svd(col_centered, nu = 1, nv = 0)
                order1 <- order(try1$u[, 1])
            }
        } else {
            if (weighted) {
                w <- weightVector / sum(weightVector)
                w_sqrt <- sqrt(w)
                toClust_weighted <- diag(w_sqrt) %*% toClust

                distMat <- as.dist(Dist(toClust_weighted,
                    method = "euclidean"
                ))
                order1 <- seriate(distMat, method = Method)
                order1 <- get_order(order1)
            } else {
                distMat <- as.dist(Dist(toClust, method = "euclidean"))
                order1 <- seriate(distMat, method = Method)
                order1 <- get_order(order1)
            }
        }
        orderObject <- list(toClust = toClust, order1 = order1)
        if (weighted) orderObject$weights <- weightVector
        if (Method != "PCA") orderObject$distMat <- distMat
    }

    if (is.function(updateProgress)) {
        updateProgress(message = "Done", value = 1)
    }
    return(orderObject)
}


recode <- function(input_GCH, input_HCG) {
    input_GCH[input_GCH == "."] <- 99
    input_GCH <- do.call(cbind, lapply(input_GCH, as.numeric))
    input_GCH[input_GCH == 2] <- -4
    input_GCH[input_GCH == 1] <- -3
    input_GCH[input_GCH == 0] <- -2.5
    input_GCH[input_GCH == -1] <- -99
    input_GCH[input_GCH == -2] <- -1
    input_GCH[input_GCH == -99] <- -2
    input_GCH[input_GCH == 99] <- 0

    input_HCG[input_HCG == "."] <- 99
    input_HCG <- do.call(cbind, lapply(input_HCG, as.numeric))
    input_HCG[input_HCG == 2] <- 4
    input_HCG[input_HCG == 1] <- 3
    input_HCG[input_HCG == 0] <- 2.5
    input_HCG[input_HCG == -1] <- 2
    input_HCG[input_HCG == -2] <- 1
    input_HCG[input_HCG == 99] <- 0

    # Recode the plot edges as white always:
    bp <- length(input_HCG[1, ])

    least_missing <- which.min(apply(input_HCG, 1, function(x) sum(x == 0)))
    firstHCG <- max(1, which(input_HCG[least_missing, ] %in% c(1, 4))[1] - 1)
    lastHCG <- min(bp, rev(which(input_HCG[least_missing, ] %in% c(1, 4)))[1] + 1)

    input_HCG <- apply(input_HCG, 1, function(x) {
        x[seq(1, firstHCG)] <- 0
        x[seq(lastHCG, bp)] <- 0
        return(x)
    })
    input_HCG <- t(input_HCG)


    firstGCH <- max(1, which(input_GCH[least_missing, ] %in% c(-1, -4))[1] - 1)
    lastGCH <- min(bp, rev(which(input_GCH[least_missing, ] %in% c(-1, -4)))[1] + 1)

    input_GCH <- apply(input_GCH, 1, function(x) {
        x[seq(1, firstGCH)] <- 0
        x[seq(lastGCH, bp)] <- 0
        return(x)
    })
    input_GCH <- t(input_GCH)

    return(list(input_GCH = data.matrix(input_GCH), input_HCG = data.matrix(input_HCG)))
}

---
title: "Using methylscaper to visualize joint methylation and nucleosome occupancy data"
author: 
- name: Rhonda Bacher
  affiliation: University of Florida
- name: Parker Knight
  affiliation: University of Florida
output:
  BiocStyle::html_document:
    toc: true
package: methylscaper
vignette: >
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteIndexEntry{Using methylscaper to visualize joint methylation and nucleosome occupancy data}
  %\usepackage[UTF-8]{inputenc}
---

<style>
.main-container {
    width: 100%;
    max-width: unset;
}
</style>

# Introduction

`methylscaper` is an R package for visualizing data that jointly profile endogenous methylation and chromatin accessibility (MAPit, NOMe-seq, scNMT-seq, nanoNOMe, etc.). The package offers pre-processing for single-molecule data and accepts input from Bismark (or similar alignment programs) for single-cell data. A common interface for visualizing both data types is done by generating ordered representational methylation-state matrices. The package provides a Shiny app to allow for interactive and optimal ordering of the individual DNA molecules to discover methylation patterns and nucleosome positioning.

**Note:** If you use methylscaper in your research, please cite [our manuscript.](https://pubmed.ncbi.nlm.nih.gov/34125875/)

If, after reading this vignette you have questions, please submit your question on GitHub: [Question or Report Issue](https://github.com/rhondabacher/methylscaper/issues). This will notify the package maintainers and benefit other users.


# Getting Started

## Installation

For local use of `methylscaper`, it can be installed into R from Bioconductor (using R version >= 4.4.0): 
```{r, eval=F}
if (!requireNamespace("BiocManager", quietly = TRUE)) {
    install.packages("BiocManager")
}

BiocManager::install("methylscaper")
```

## Load the package

After successful installation, load the package into the working space.
```{r, message = FALSE, warning=FALSE}
library(methylscaper)
```

To access the Shiny app, simply run:
```{r, eval=F}
methylscaper()
```

# Visualizing single-cell data

For visualizing single-cell data from methods such as scNMT-seq, methylscaper begins with pre-aligned data. For each cell, there should be two files, one for the GCH sites and another for the HCG sites. The minimal number of columns needed for methylscaper is three: chromosome, position, and methylation status. This type of file is generated via the "Bismark\_methylation\_extractor" script in the Bismark software tool. The extractor function outputs files in four or six column output files (see bedGraph option described here: https://felixkrueger.github.io/Bismark/options/methylation_extraction/). Methylscaper will accept these and convert to the three column format internally.

Due to the large file size, methylscaper further processes the data for the visualization analysis to the chromosome level. In the Shiny app, first select all files associated with the endogenous methylation and then select all files associated with accessibility. The files should be named in such a way that the file pairs can be inferred (e.g "Expr1_Sample1_met" pairs with "Expr1_Sample1_acc"). Finally, indicate the desired chromosome to filter to the chromosome level. 

### Example data for single-cell data

Below we walk through an example using data from Clark et al., 2018, obtained from
[GSE109262](https://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?acc=GSE109262). For
the sake of this example, we assume that the `GSE109262_RAW.tar`
directory is downloaded locally to `~/Downloads/`.

### Preprocessing in the Shiny app


In the screenshot below, the data from GSE10926 data on chromosome 19 is ready for processing. When selecting "Browse...", be sure to  select **all** relevant files for each methylation type.

![Screenshot: Preprocessing tab for single-cell data](process_sc.png){#id .class width=100% height=100%}

## Preprocessing using methylscaper functions


The preprocessing can also be done in the R console directly, which allows for additional start and end specifications. For the purpose of creating a small example to include in the package, we additionally restricted the data between base pairs 8,947,041 to 8,987,041, which is centered around the *Eef1g* gene. In practice, we advise users to filter to just the chromosome level to keep the region relatively large. The [Visualization tab](vizinApp) allows for a more refined search along the chromosome and is described in a section below.

When using methylscaper within R, rather than specifying all the files individually, simply point to a folder which contains two subfolders with the accessibility and endogenous methylation files. These subfolders must be named "acc" and "met", respectively.


```{r, eval=FALSE}
filepath <- "~/Downloads/GSE109262_RAW/"
singlecell_subset <- subsetSC(filepath, chromosome = 19, startPos = 8937041, endPos = 8997041)
# To save for later, save as an rds file and change the folder location as desired:
saveRDS(singlecell_subset, "~/Downloads/singlecell_subset.rds")
```

For a reproducible example, we have provided three cells for [download](https://rbacher.rc.ufl.edu/methylscaper/content/exampledata.html), and below we run an example where we read the data directly from the URLs into R and use the subsetSC function. If you choose to download these files, then the directions above should be followed by moving the files into subfolders named "acc" and "met".

```{r, eval=TRUE}
gse_subset_path <- list(
    c(
        "https://rbacher.rc.ufl.edu/methylscaper/data/GSE109262_SUBSET/GSM2936197_ESC_A08_CpG-met_processed.tsv.gz",
        "https://rbacher.rc.ufl.edu/methylscaper/data/GSE109262_SUBSET/GSM2936196_ESC_A07_CpG-met_processed.tsv.gz",
        "https://rbacher.rc.ufl.edu/methylscaper/data/GSE109262_SUBSET/GSM2936192_ESC_A03_CpG-met_processed.tsv.gz"
    ),
    c(
        "https://rbacher.rc.ufl.edu/methylscaper/data/GSE109262_SUBSET/GSM2936197_ESC_A08_GpC-acc_processed.tsv.gz",
        "https://rbacher.rc.ufl.edu/methylscaper/data/GSE109262_SUBSET/GSM2936196_ESC_A07_GpC-acc_processed.tsv.gz",
        "https://rbacher.rc.ufl.edu/methylscaper/data/GSE109262_SUBSET/GSM2936192_ESC_A03_GpC-acc_processed.tsv.gz"
    ),
    c("GSM2936197_ESC_A08_CpG-met_processed", "GSM2936196_ESC_A07_CpG-met_processed", "GSM2936192_ESC_A03_CpG-met_processed"),
    c("GSM2936197_ESC_A08_GpC-acc_processed", "GSM2936196_ESC_A07_GpC-acc_processed", "GSM2936192_ESC_A03_GpC-acc_processed")
)
# This formatting is a list of 4 objects: the met file urls, the acc file urls, the met file names, and the acc file names.
options(timeout = 1000)
singlecell_subset <- subsetSC(gse_subset_path, chromosome = 19, startPos = 8937041, endPos = 8997041)

# To save for later, save as an rds file and change the folder location as desired:
# saveRDS(singlecell_subset, "~/Downloads/singlecell_subset.rds")
```

To fully demonstrate the example using the three cells subset, we skip some explanations of the functions and show the resulting plot. For this particular region only one of the three cells has coverage and thus only one row is shown in the plot (if a cell has no data in the entire region then it is not shown in the plot rather than being plot as missing data). All functions are further explained in detail in the following sections.

```{r, eval=TRUE, fig.width=7, fig.height=3}
data("mouse_bm")
gene.select <- subset(mouse_bm, mgi_symbol == "Eef1g")

startPos <- 8966841
endPos <- 8967541
prepSC.out <- prepSC(singlecell_subset, startPos = startPos, endPos = endPos)

orderObj <- initialOrder(prepSC.out)
plotSequence(orderObj, Title = "Eef1g gene", plotFast = TRUE, drawKey = FALSE)
```

## Visualization in the Shiny app {#vizinApp}

The screenshot below is of the Visualization tab in the methylscaper Shiny app. First, indicate the location of the singlecell_subset.rds file. Once the file is loaded, we have included preset gene locations for Mouse (GRCm39) and Human (GRCh38), so that a gene can be selected. The input box can also be typed in and genes will begin to appear; this is the easiest way to navigate. The default start and end positions are those of the entire gene, however, a slider will appear that allows the user to refine the genomic location of interest. The start and end positions can also be manually entered. For any other organism, the start and end positions should be entered manually.


In the visualization, two plots will appear. They both represent the same genomic region, but they are colored based on either HCGH or GCH sites. The x-axis represents the genomic location, and the y-axis is each individual cell. The left plot contains the genomic region mapped to HCG sites (sites are indicated by tick marks at the top), and the right plot contains the genomic region mapped to GCH sites. For HCG (i.e. endogenous methylation), methylscaper colors patches in between each HCG site as follows: If two consecutive HCG sites are methylated, a red patch is present. If two consecutive HCG sites are unmethylated, a black patch is present. If two consecutive HCG sites are inconsistently methylated, a gray border or patch appears. For GCH (i.e. accessibility), methylscaper colors patches as follows: yellow patches occur between two methylated sites (an accessible region), black patches occur between two unmethylated sites (inaccessible region), and gray patches occur between inconsistent methylation of consecutive sites. Any missing data (e.g. no reads covered that region for a particular cell) will show up as a white patch in either plot.


![Screenshot: Visualization of the *Tut1* gene](sc.png){#id .class width=100% height=100%}

Once a region is chosen, the default ordering by methylscaper is the unweighted PCA. The user is then able to dynamically weight and refine the plot via Shiny's brushing mechanics. The user can click and drag the mouse across the plot horizontally to choose which bases (i.e. columns) should be weighted in the global PCA ordering. The plot will update and two green lines will appear to indicate the weighting positions (note that these are not included once the plot is downloaded).

With "PCA" selected as the seriation method, the new ordering will be generated with a weighted Principal Components Analysis. The weighting is done on the proportion of methylation within the specified region. We recommend using "PCA" as the ordering method. However, for comparison purposes, we have also included the "ARSA" method. In ARSA the ordering is found by first building a weighted Euclidean distance matrix, which is then passed to the Simulated Annealing algorithm in the seriation package. This method tends to work well on smaller datasets, but due to computational inefficiency, it is generally not recommended for very large datasets at this time.

The next (optional) step is to locally refine the ordering of reads. In this case, select refinement and begin to click and drag the mouse vertically to choose which cells should be reordered. Blue lines will be drawn to indicate the refined cells. PCA is used by default and is also recommended, however, we provide hierarchical clustering as an option for the refinement method in the Shiny app for comparison purposes. Unlike re-weightings, refinements to the sequence plot stack onto each other, and several refinements can be done to a single plot before exporting. However, it is important to note that re-weighting the sites will reorder the entire set of data, and hence will undo any refinements that you may have made.

After making any desired changes, the sequence plot can be saved as either a PNG or PDF file. Additionally, `methylscaper` keeps track of all changes made to the plots in the form of a changes log, which can be saved as a text file.

The final plot and a log indicating the weighting and refinement choices for reproducibility can then be downloaded.

## Visualization using methylscaper functions

The visualization can be done using methylscaper functions as well. Each function is described individually below. There are some additional options the user can control when using the functions within the R console. 

```{r, eval=TRUE, fig.align='left', fig.width=6, fig.height=5}
# If you followed the preprocessing code above, then you can do:
# mydata <- readRDS("~/Downloads/singlecell_subset.rds")
# Otherwise, we have also included this subset in the package directly:
mydata <- system.file("extdata", "singlecell_subset.rds", package = "methylscaper")
mydata <- readRDS(mydata)
gene <- "Eef1g"
data("mouse_bm") # for human use human_bm
gene.select <- subset(mouse_bm, mgi_symbol == gene)
# We will further subset the region to a narrow region of the gene: from 8966841bp to 8967541bp
startPos <- 8966841
endPos <- 8967541

# This subsets the data to a specific region and prepares the data for visualization:
prepSC.out <- prepSC(mydata, startPos = startPos, endPos = endPos)

# Next the cells are ordered using the PCA approach and plot
orderObj <- initialOrder(prepSC.out)
plotSequence(orderObj, Title = "Eef1g gene", plotFast = TRUE)
# We plot the nucleosome size key by default, however this can be turned off via drawKey = FALSE:
# plotSequence(orderObj, Title = "Eef1g gene", plotFast=TRUE, drawKey = FALSE)
```

The function `prepSC` generates the `gch` and `hcg` objects, which are matrices representing accessibility
and methylation status, respectively. These matrices are used by other
`methylscaper` functions for visualization and summary plots.

The `initialOrder` function computes an ordering of the state matrices, using a given method. By default, the function uses our PCA-based ordering, which we find optimally and efficiently scales to large datasets, though we have written the function to allow any method supported by the `seriation` package to be input to the Method parameter. 

To perform the weighted ordering, either on the methylation or accessibility status, we can indicate the positions as follows. The `weightFeature` should be either for 'met' (endogenous methylation) or 'acc' (accessibility).

```{r, eval=TRUE}
orderObj <- initialOrder(prepSC.out,
    weightStart = 47, weightEnd = 358, weightFeature = "acc"
)
```


The sequence plot is then generated with the `plotSequence` function. The option 'plotFast' sets the plot parameter useRaster to TRUE, which generates a fast-loading bitmap image. To save with high resolution, change 'plotFast' to TRUE. In the Shiny app, the download button automatically generates the high resolution version.


```{r, eval=TRUE, fig.width=7, fig.height=6}
plotSequence(orderObj, Title = "Eef1g gene", plotFast = TRUE)
```

We can also refine the ordering of the reads with `refineFunction`,
which reorders a subset of the reads with a given method. The
code below reorders the first 20 cells and generates a new sequence plot.

```{r, eval=TRUE, fig.width=7, fig.height=6}
orderObj$order1 <- refineFunction(orderObj, refineStart = 1, refineEnd = 20)
plotSequence(orderObj, Title = "Eef1g gene", plotFast = TRUE)
```

Within R, there is more control over the output resolution of the plot. For example, we can
control the resolution when outputting as a PNG. Note that saving as PNG with the best quality and size 
takes some trial and error. You may need to increase the width/height for a given resolution. Saving as PDF
is automatically high resolution, though you will still want to adjust the width and height to your preference.

```{r, eval=FALSE}
png("~/save_my_plot.png", width = 4, height = 6, units = "in", res = 300)
plotSequence(orderObj, Title = "Eef1g gene", plotFast = FASLE)
dev.off()
```

### Accessing gene positions via biomaRt objects


In the Shiny app, we have included pre-downloaded versions of the mouse (GRCm39) and human (GRCh38) gene locations for ease of use. If you wish to use another organism, we demonstrate below how to obtain these from biomaRt.

```{r, eval=FALSE}
# if (!requireNamespace("biomaRt", quietly = TRUE)) {
#     BiocManager::install("biomaRt")
# }
library(biomaRt)
ensembl <- useMart("ensembl")
# Demonstrating how to get the human annotations.
ensembl <- useDataset("hsapiens_gene_ensembl", mart = ensembl)
my_chr <- c(1:22, "M", "X", "Y") # You can choose to omit this or include additional chromosome
# We only need the start, end, and symbol:
human_bm <- getBM(
    attributes = c("chromosome_name", "start_position", "end_position", "hgnc_symbol"),
    filters = "chromosome_name",
    values = my_chr,
    mart = ensembl
)

## Now that we have the biomart object, we can extract start and ends for methylscaper:
gene_select <- subset(human_bm, human_bm$hgnc_symbol == "GeneX")

# These can then be passed into the prepSC function:
prepSC.out <- prepSC(mydata, startPos = gene_select$startPos, endPos = gene_select$endPos)

# To continue the analysis:
# Next the cells are ordered using the PCA approach and then plot:
orderObj <- initialOrder(prepSC.out)
plotSequence(orderObj, Title = "Gene X", plotFast = TRUE)
```


# Visualizing single-molecule data

For single-molecule data from MAPit type experiments, methylscaper will first preprocess the reads by aligning reads contained in a fasta file to a reference file containing the sequence of interest (also in fasta format). This analysis can also be done in either the Shiny app or in the R console.

### Preprocessing in the Shiny app

For the Shiny app, the input should be a list of reads in a fasta format and a fasta reference file. The reference sequence file should be input in the 5’ to 3’ orientation (Watson strand). We do not include GCG sites because their status is biologically ambiguous. Thus, we denote GC sites that are not followed by a G as GCH and CG sites that are not preceded by a G as HCG.

The screenshot below shows this preprocessing step. We make use of data from our [manuscript](https://academic.oup.com/bioinformatics/article/37/24/4857/6298588) and the raw data is provided in the methylscaper package. The files can also be downloaded directly from the methylscaper website: [Example Data](https://rbacher.rc.ufl.edu/methylscaper/content/exampledata.html). After selecting 'Run', a progress bar will appear in the bottom right. Once completed, the data may be downloaded along with a log file indicating the number of molecules successfully processed.

After selecting 'Run', a progress bar will appear in the bottom right. Once completed, the data may be downloaded along with a log file indicating the number of molecules successfully processed.
 
![Screenshot: Preprocessing tab for single-molecule data](process_sm.png){#id .class width=100% height=100%}

### Preprocessing using methylscaper functions

To run the preprocessing in the R console, the function `runAlign` may be used. The sequences are aligned to the reference using the `Biostrings` package and then mapped to the methylation- and accessibility-state matrices. For very large datasets, the runAlign function has a multicoreParam parameter for running methylscaper on high-throughput servers rather than locally.

```{r, eval = TRUE}
# This provides the path to the raw datasets located in the methylscaper package
seq_file <- system.file("extdata", "seq_file.fasta", package = "methylscaper")
ref_file <- system.file("extdata", "reference.fa", package = "methylscaper")

# Next we read the data into R using the read.fasta function from the seqinr package:
fasta <- seqinr::read.fasta(seq_file)
ref <- seqinr::read.fasta(ref_file)[[1]]

# For the vignette we will only run a subset of the molecules
singlemolecule_example <- runAlign(fasta = fasta, ref = ref, fasta_subset = 1:150)

# Once complete, we can save the output as an RDS object
# saveRDS(singlemolecule_example, file="~/methylscaper_singlemolecule_preprocessed.rds")
```


### Visualization in the Shiny app

![Screenshot: Visualizing the single-molecule data](sm.png){#id .class width=100% height=100%}

### Visualization using the methylscaper functions

Analysis of the single-molecule data in the R console uses the same functions described above in the single-cell section.

```{r, eval=TRUE, fig.width=7, fig.height=6}
# If skipping the preprocessing steps above, use our pre-aligned data:
# data(singlemolecule_example)
orderObj <- initialOrder(singlemolecule_example,
    Method = "PCA",
    weightStart = 308, weightEnd = 475, weightFeature = "red"
)
plotSequence(orderObj, Title = "Ordered by PCA", plotFast = TRUE)
```


<!-- ```{r, eval=FALSE, fig.width=7, fig.height=6} -->
<!-- orderObj$order1 <- refineFunction(orderObj, refineStart = 6, refineEnd = 1, Method = "PCA") -->
<!-- plotSequence(orderObj, Title = "Ordered by PCA", plotFast = TRUE) -->
<!-- ``` -->


# Additional summary plots

Both single-cell and single-molecule data can be additionally summarized using methylscaper functions. The summary plots are restricted to the genomic region selected in the Shiny App or those used in the initialOrder function.

* The methyl_proportion function calculates the proportion of bases that are methylated within each cell or molecule. A histogram displays these proportions. It should be indicated using the `type` parameter to calculate this over the endogenous methylation profile or the accessibility.

* The methyl_percent_sites function calculates the percent of GCH (yellow; accessibility) or HCG (red; endogenous methylation) sites that are methylated across all cells or molecules.

* The methyl_average_status function is similar to methyl_percent_sites but calculates an average methylation status across all cells or molecules within a specified window.

```{r, eval=TRUE, fig.align='left', fig.height=8, fig.width=8}
par(mfrow = c(2, 2))
props <- methyl_proportion(orderObj, type = "met", makePlot = TRUE, main = "")
props <- methyl_proportion(orderObj, type = "acc", makePlot = TRUE, main = "")

pcnts <- methyl_percent_sites(orderObj, makePlot = TRUE)
avgs <- methyl_average_status(orderObj, makePlot = TRUE, window_length = 25)
```

# FAQ

Frequently asked questions will be entered here.

# SessionInfo

```{r sessionInfo, results='markup'}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/refinement.R
\name{refineFunction}
\alias{refineFunction}
\title{Refinement}
\usage{
refineFunction(orderObject, refineStart, refineEnd, Method = "PCA")
}
\arguments{
\item{orderObject}{An object of class \code{orderObject}, generated
with the \code{initialOrder} function.}

\item{refineStart}{The index of the first sample (row) used
in the refinement.}

\item{refineEnd}{The index of the last sample (row) used in the refinement.}

\item{Method}{The seriation method used to perform the refinement.}
}
\value{
The refinement reorders the cells/molecules (rows) between the indicated
start and end positions. The function returns the new complete ordering
with the refinement applied.
}
\description{
Reorders a subset of the methylation data.
}
\examples{

data(singlemolecule_example)

orderObj <- initialOrder(singlemolecule_example, Method = "PCA")
# reordering the first 50 cells/molecules (rows)
orderObj$order1 <- refineFunction(orderObj, 1, 50)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessSingleMolecule.R
\name{runAlign}
\alias{runAlign}
\title{Align the single-molecule data}
\usage{
runAlign(
  ref,
  fasta,
  fasta_subset = seq(1, length(fasta)),
  multicoreParam = NULL,
  updateProgress = NULL,
  log_file = NULL,
  score_cutoff = NULL
)
}
\arguments{
\item{ref}{A reference sequence to align the reads to.}

\item{fasta}{A list of reads/sequences from a single-molecule experiment (e.g. MAPit)}

\item{fasta_subset}{(optional) A vector of indices indicating which
sequences to process if a subset should be used. Leave this blank if
all sequences should be processed.}

\item{multicoreParam}{(optional) A MulticoreParam object, used to align
sequences in parallel.}

\item{updateProgress}{(optional) Used to add a progress bar to the Shiny app.
Should not be used otherwise.}

\item{log_file}{(optional) String indicating where to save a log of the
alignment process. If left NULL, no log is saved. We highly recommend
saving a log file.}

\item{score_cutoff}{(optional) Used mostly for testing purposes.}
}
\value{
The output is a list containing the the matrices 'gch' and 'hcg.
      Each is a dataframe with reads/cells on the rows and each column
     is a base-pair. The matrix represents the methylation state for cell
     across all base pairs. The coding is as follows:
         -2: unmethylated GCH or HCG site
         -1: base pairs between two unmethylated GCH or HCG sites
         0: base pairs between mismatching methylation states of
             two GCH or HCG sites
         1: base pairs between two methylated GCH or HCG sites
         2: methylated GCH or HCG site
}
\description{
Runs the preprocessing methods for single-molecule data.
}
\examples{

data(reads_sm)
data(ref_seq)
example_alignedseq <- runAlign(fasta = reads_sm, ref = ref_seq[[1]], fasta_subset = 1:150)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summaryPlots.R
\name{methyl_percent_sites}
\alias{methyl_percent_sites}
\title{Calculates the percentage of methylated cells/molecules per site}
\usage{
methyl_percent_sites(orderObject, makePlot = TRUE, ...)
}
\arguments{
\item{orderObject}{An object of class \code{orderObject}}

\item{makePlot}{Logical, indicates whether to generate the percentage plot}

\item{...}{Additional parameters used by the \code{plot} function.}
}
\value{
The percent of molecules or cells methylated (endogenous (yellow)
     or accessible) at each site. Output is a list with names "red"
     and "yellow". Red represents the endogenous methylation and
     yellow represents the accessibility. Within each list object is a
     vector of the percent of cells/molecules methylated. The location
     of the site is also represent in the form CXX, where XX is the
     position of the site within the defined region.
}
\description{
Calculates the percentage of methylated cells/molecules per site
}
\examples{

data(singlemolecule_example)

orderObj <- initialOrder(singlemolecule_example, Method = "PCA")
methyl_percent_sites(orderObj, makePlot = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summaryPlots.R
\name{methyl_proportion}
\alias{methyl_proportion}
\title{Calculate the proportion of methylated bases for each cell/molecule}
\usage{
methyl_proportion(orderObject, type = "yellow", makePlot = TRUE, ...)
}
\arguments{
\item{orderObject}{An object of class \code{orderObject}}

\item{type}{Indicates which data set to compute proportions for.
This should be 'met' or 'hcg' or 'red' for endogenous methylation; 'acc' or
'gch' or 'yellow' for accessibility.}

\item{makePlot}{Indicates whether to plot a histogram of the proportions
across all cells/molcules.}

\item{...}{Additional parameters used by the \code{hist} function.}
}
\value{
The proportion of methylated (endogenous (yellow)
     or accessible) bases for each cell/molecule. Output is vector
     with length the numbner of cells/molecules and contains a proportion.
}
\description{
Calculate the proportion of methylated bases for each cell/molecule
}
\examples{

data(singlemolecule_example)

orderObj <- initialOrder(singlemolecule_example, Method = "PCA")
methyl_proportion(orderObj, makePlot = TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summaryPlots.R
\name{methyl_average_status}
\alias{methyl_average_status}
\title{Calculate the average methylation/accessibility status across all cells/molecules.}
\usage{
methyl_average_status(orderObject, window_length = 20, makePlot = TRUE, ...)
}
\arguments{
\item{orderObject}{An object of class \code{orderObject}}

\item{window_length}{Length of the window to be used to compute a
moving average. Default is 20.}

\item{makePlot}{Logical, indicates whether to generate a line plot of
average status.}

\item{...}{Addition parameters used by the \code{plot} function.}
}
\value{
The proportion of methylated bases for each cell/molecule
     within a defined moving window. Output is a list with elements
     "meth_avg" and "acc_avg", indicating endogenous
     or accessible methylation respectively.
}
\description{
Calculate the average methylation/accessibility status across all cells/molecules.
}
\examples{

data(singlemolecule_example)

orderObj <- initialOrder(singlemolecule_example, Method = "PCA")
methyl_average_status(orderObj, makePlot = TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ioHelpers.R
\name{reformatSCE}
\alias{reformatSCE}
\title{This is an internal function for now and a place-holder
in case SingleCellExperiment may be
used in the future. We may need to update this later. Assumes
rownames are formatted like chr_pos and there are two assays.
The assay names are `methylation_met` for endogenous methylation
and `methylation_acc` for accessibility.}
\usage{
reformatSCE(dataIn)
}
\arguments{
\item{dataIn}{Input SCE object passed to the prepSC() function.}
}
\value{
List object containing the met and acc tables.
}
\description{
This is an internal function for now and a place-holder
in case SingleCellExperiment may be
used in the future. We may need to update this later. Assumes
rownames are formatted like chr_pos and there are two assays.
The assay names are `methylation_met` for endogenous methylation
and `methylation_acc` for accessibility.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/app.R
\name{methylscaper}
\alias{methylscaper}
\title{methylscaper}
\usage{
methylscaper()
}
\value{
This starts up the shiny app interface for methylscaper.
}
\description{
Runs the methylscaper Shiny app.
}
\examples{

# methylscaper()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{ref_seq}
\alias{ref_seq}
\title{Example reference sequence to align reads to from a
single-molecule experiment}
\format{
An object of class \code{list} of length 1.
}
\usage{
data(ref_seq)
}
\description{
This dataset was loaded into R using seqinr::read.fasta
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{singlecell_subset}
\alias{singlecell_subset}
\title{Example preprocessed single-cell experiment subset}
\format{
An object of class \code{list} of length 2.
}
\usage{
data(singlecell_subset)
}
\description{
This data is from GSE109262, and has been pre-processed by methylscaper
It contains a small subset of chromosome 19 region from 8947041bp - 8987041bp.
The RDS in ext data was made specifically with the two commands:
singlecell_subset <- subsetSC("~/Downloads/GSE109262_RAW/", chromosome="19",
   startPos = 8967041-20000, endPos = 8967041+20000, updateProgress = NULL)
saveRDS(singlecell_subset, file="methylscaper/inst/ext/singlecell_subset.rds", compress = 'xz')
A version is also saved as RData used running examples in the man pages.
save(singlecell_subset, file="methylscaper/data/singlecell_subset.RData", compress = 'xz')
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/initialOrder.R
\name{initialOrder}
\alias{initialOrder}
\title{Ordering the molecules/reads}
\usage{
initialOrder(
  dataIn,
  Method = "PCA",
  weightStart = NULL,
  weightEnd = NULL,
  weightFeature = "red",
  updateProgress = NULL
)
}
\arguments{
\item{dataIn}{A list object containing two elements labelled gch and hcg (already pre-processed.)}

\item{Method}{Indicates the seriation method to use. The default option
is "PCA", which orders the data using a weighted first principal component approach. Any
seriation method provided in the \code{seriation} package is also valid input.}

\item{weightStart}{Index of the first column used in the weighted seriation.}

\item{weightEnd}{Index of the last column used in the weighted seriation.}

\item{weightFeature}{Indicates whether to weight the GCH or HCG data.
Valid input to weight the GCH is 'gch', 'acc', or 'yellow'. To weight the HCG,
valid input for this option is 'hcg', 'met', or 'red'.}

\item{updateProgress}{A function to handle the progress bar for the
Shiny app. Should not be used when using the function independently.}
}
\value{
An object of class \code{orderObject}, which contains the generated
 ordering ($order1) and a clean data matrix ($toClust)
 to be passed into the plotting function plotSequence().
}
\description{
This function performs the weighted seriation procedure
described in the methylscaper manuscript if the method is set to "PCA".
The data may also be ordered using a given seriation method from the
seriation R package. The weighting is done between a designated start and end
base pair chosen by the user, and the weight can be done on the
endogenous methylation or the accessibility.
}
\examples{

data(singlemolecule_example)

orderObj <- initialOrder(singlemolecule_example)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{singlemolecule_example}
\alias{singlemolecule_example}
\title{Example preprocessed single-molecule experiment}
\format{
An object of class \code{list} of length 2.
}
\usage{
data(singlemolecule_example)
}
\description{
The RDS in ext data was made specifically with the command:
singlemolecule_example <- methylscaper::runAlign(fasta=reads_sm,
ref=ref_seq)
saveRDS(singlemolecule_example, file="methylscaper/inst/ext/singlemolecule_example.rds", compress = 'xz')
A version is also saved as RData used running examples in the man pages.
save(singlemolecule_example, file="methylscaper/data/singlemolecule_example.RData", compress = 'xz')
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/seqPlot.R
\name{plotSequence}
\alias{plotSequence}
\title{Generate Sequence Plot}
\usage{
plotSequence(
  orderObject,
  plotFast = TRUE,
  blankWidth = NULL,
  Title = "",
  drawLine = TRUE,
  drawKey = TRUE,
  shinySizer = 0
)
}
\arguments{
\item{orderObject}{An object of class \code{orderObject} that contains
the processed data and the ordering.}

\item{plotFast}{Logical, setting to FALSE will generate a higher
quality plot. TRUE generates a lower resolution file, useful to improve
speed while testing. For publication quality use plotFast=TRUE.}

\item{blankWidth}{Indicates the amount of space to leave between
the two plots}

\item{Title}{The title of the plot.}

\item{drawLine}{Logical, indicates whether to draw a line above
the CG/GC sites.}

\item{drawKey}{Logical, indicates whether to draw a key representing
a 147bp nucleosome at the bottom of the plot.}

\item{shinySizer}{internal sizing parameter for plot layout in shiny app.}
}
\value{
Output is two side-by-side heatmaps with the endogenous
   methylation (HCG) on the left and the acciessibility methylation (GCH)
   on the right. The tick marks at the top indicate
   either HCG or GCH sites when drawLine=TRUE. If drawKey=TRUE then a black
   rectangle key is plot at the bottom of the heatmap that is 147 basepairs
   long. In the HCG plot, red patches represent methylation between two
   sites; black patches represent unmethylated bases between two
   unmethylated sites; and gray patches are base pairs which have one
   methylated site and one unmethylated site flanking. In the HCG plot,
   yellow patches represent accessibility between two sites; black patches
   represent occupied bases  between two occupied sites; and gray patches
   are base pairs which have one methylated site and one
   unmethylated site flanking.
}
\description{
Generates an ordered sequence plot of methylation data.
}
\examples{

data(singlemolecule_example)

orderObj <- initialOrder(singlemolecule_example, Method = "PCA")
plotSequence(orderObj)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ioHelpers.R
\name{check_package}
\alias{check_package}
\title{Check if a package is installed}
\usage{
check_package(package)
}
\arguments{
\item{package}{Name of the package.}
}
\value{
Message is returned if package not installed.
}
\description{
Check if a package is installed
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{human_bm}
\alias{human_bm}
\title{Human gene symbols and positions}
\format{
An object of class \code{data.frame} with 60580 rows and 4 columns.
}
\usage{
data(human_bm)
}
\description{
library(biomaRt) #v2.44.4
ensembl <- useMart("ensembl") # GRCh38
ensembl <- useDataset("hsapiens_gene_ensembl",mart=ensembl)
my_chr <- c(1:22, 'M', 'X', 'Y')
human_bm <- getBM(attributes=c('chromosome_name', 'start_position', 'end_position', 'hgnc_symbol'),
            filters = 'chromosome_name',
            values = my_chr,
            mart=ensembl)
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessSingleCell.R
\name{subsetSC}
\alias{subsetSC}
\title{Load in methylation data}
\usage{
subsetSC(
  path,
  chromosome,
  startPos = NULL,
  endPos = NULL,
  updateProgress = NULL
)
}
\arguments{
\item{path}{Path to the folder containing the single-cell files.}

\item{chromosome}{The chromosome to subset the files to.}

\item{startPos}{The index of the first position to include
in the subsetting. This is optional as further narrowing of the
position can be done in the visualization step/tab.
In the Shiny app, a slider will let the user refine the positions.}

\item{endPos}{The index of the final position to include in subset.}

\item{updateProgress}{A function for generating progress bars in the Shiny app.
Should be left NULL otherwise.}
}
\value{
The output is RDS files that can be loaded into the visualization
 tab on the Shiny app
}
\description{
This function loads the single-cell files. It takes a path to the data files
and a chromosome number as arguments and returns the desired subset of the
data. Processing by chromosome is important for speed and memory efficiency.
The input files should be tab separated with three columns.
The first column is the chromosome, the second is the position (basepair), and the third
is the methylation indicator/rate. The folder should contain two subfolders titled
met and acc, with the endogenous methylation and accessibility methylation files,
respectively.
}
\examples{
# example not run since needs directory input from user
# subsc.out <- subsetSC("filepath", chromosome=19)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{reads_sm}
\alias{reads_sm}
\title{Example reads from single-molecule experiment}
\format{
An object of class \code{list} of length 293.
}
\usage{
data(reads_sm)
}
\description{
This dataset was loaded into R using seqinr::read.fasta
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/refinement.R
\name{forceReverse}
\alias{forceReverse}
\title{Force reversal of a subset of the ordering}
\usage{
forceReverse(
  orderObject,
  reverseStart = 1,
  reverseEnd = length(orderObject$order1)
)
}
\arguments{
\item{orderObject}{An object of class \code{orderObject},
generated with the \code{initialOrder} function.}

\item{reverseStart}{The first index to be included in the reversal.}

\item{reverseEnd}{The last index to be included in the reversal.}
}
\value{
The new complete ordering, with the reversal applied.
}
\description{
This reverses a subset of the ordering, as determined by the user.
By default, the entire ordering is reversed.
}
\examples{

data(singlemolecule_example)

orderObj <- initialOrder(singlemolecule_example, Method = "PCA")
# reorder first 50 cells/molecules (rows)
orderObj$order1 <- refineFunction(orderObj, 1, 50)
orderObj$order1 <- forceReverse(orderObj, 1, 50)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/preprocessSingleCell.R
\name{prepSC}
\alias{prepSC}
\title{Process single-cell data}
\usage{
prepSC(dataIn, startPos = NULL, endPos = NULL, updateProgress = NULL)
}
\arguments{
\item{dataIn}{A list object containing two elements labelled gch and hcg (already pre-processed.)}

\item{startPos}{The index of the first position to include
in the visualization. If using this within the R console it is
recomended to specify the start and end directly.
In the Shiny app, a slider will let the user refine these positions.}

\item{endPos}{The index of the final position to include in the visualization.}

\item{updateProgress}{A function for generating progress bars in the Shiny app.
Should be left NULL otherwise.}
}
\value{
The output is a list containing the elements 'gch' and 'hcg.
     Each is a dataframe with reads/cells on the rows and each column
     is a base-pair. The matrix is coded as follows:
         -2: unmethylated GCH or HCG site
         -1: base pairs between two unmethylated GCH or HCG sites
         0: base pairs between mismatching methylation states of
             two GCH or HCG sites
         1: base pairs between two methylated GCH or HCG sites
         2: methylated GCH or HCG site
}
\description{
This function subsets the data and prepares it for visualizing by
generating representation methylation-state matrices from
single-cell methylation data (for example, sc-MNT data).
We assume the data has already been preprocess using the subsetSC
function in methylscaper. See the vignette for a more thorough
explanation of each parameter. The output should be passed directly to the
plotting function.
}
\examples{

data(singlecell_subset)
prepsc.out <- prepSC(singlecell_subset,
    startPos = 105636488, endPos = 105636993
)
}
